#┌─────────────────────────────────
#│ [ WebPatio ]
#│ check.pl - 2006/10/08
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#└─────────────────────────────────

#-------------------------------------------------
#  チェックモード (各掲示板会議室の設定内容チェック)
#-------------------------------------------------
$sver = 'v1.43';
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義ヘッダー対応のコラム背景画像クラスを追加

use utf8;

sub check {

	my $pagetitle = $title ? $title."の設定内容チェック" : "掲示板の設定内容チェック";

	my $hothour = int ($hot/3600);
#	my $maxdata = int ($maxdata/1000);
	if (!$room) { $room_url = '.'; }
#	$roomnote = $room . "note.html";
	$notepage =~ s/&/&amp;/g;
	
	&header();
	$printString = <<"EOM";
<div align="center">
<table $width><tr><td align=right nowrap>
<a href="$patioshtml">トップページ</a> &gt; <a href="$notepage">留意事項</a> &gt; 設定内容
</td></tr></table>
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/book.gif" align="top" alt="book">
&nbsp; <b>$pagetitle</b></td>
<td $bgclass2 align="right" bgcolor="$col3" nowrap>
<a href="javascript:history.back()">前画面に戻る</a></td>
</tr></table>
<p>
<table bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2"><td $bgclass align="left" bgcolor="$col1">
	<font color="$col6"><b>この会議室のインストール状況</b></font>
</td></tr></table>
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2">
<td align="left" bgcolor="$col2" nowrap>

<h3>チェックモード</h3>
<ul>
EOM
print &strEncode($printString);

	if ($room) {
		print &strEncode("<li>会議室のタイトル: $title\n");
		print &strEncode("<li>会議室のルートディレクトリ: $roomdir\n");
		print &strEncode("<li>会議室のルートURL(フルパス): $url_root$room_url\n");
		print &strEncode("<li>会議室の個別設定.iniファイル: $roomdir/$room.ini\n") if ($room);
		print &strEncode("<li>会議室の留意事項ファイル(フルパス): $url_root$notepage\n") if ($room);
		print "</ul><ul>";
	}

	local(%dir) = (
		$datadir, "データディレクトリ",
		$logdir, "ログディレクトリ",
		$sesdir, "セッションディレクトリ",
		$upldir, "アップロードディレクトリ",
	);
	foreach ( keys(%dir) ) {
		if (-d $_) {
			print &strEncode("<li>$dir{$_}のパス : OK!\n");

			if (-w $_ && -r $_ && -x $_) {
				print &strEncode("<li>$dir{$_}のパーミッション : OK!\n");
			} else {
				print &strEncode("<li>$dir{$_}のパーミッション : NG → $_\n");
			}
		} else {
			print &strEncode("<li>$dir{$_}のパス : NG → $_\n");
		}
	}

	print "</ul><ul>";

	local(%log) = (
		$nowfile,  "現行ファイル",
		$pastfile, "過去ファイル",
		$memfile,  "会員ファイル",
	);

	foreach ( keys(%log) ) {
		if (-f $_) {
			print &strEncode("<li>$log{$_}のパス : OK!\n");

			if (-w $_ && -r $_) {
				print &strEncode("<li>$log{$_}のパーミッション : OK!\n");
			} else {
				print &strEncode("<li>$log{$_}のパーミッション : NG → $_\n");
			}
		} else {
			print &strEncode("<li>$log{$_}のパス : NG → $_\n");
		}
	}

	# FEED機能実装による追加 （2009/11/05 スガラボット追加修正)
	if ($feed) {
		if (-f $feedlog) {
			print &strEncode("<li>FEEDログファイルのパス : OK!\n");
			if (-w $feedlog && -r $feedlog) { print &strEncode("<li>FEEDログファイルのパーミッション : OK!\n"); }
			else { print &strEncode("<li>FEEDログファイルのパーミッション : NG → $feedlog\n"); }
		} elsif ($feedlog) {
			require $feedpl;
			&feed('create');
			print &strEncode("<li><div style=\"color:red;\">FEEDログファイルが無かったので作成しました!</div>\n");
			print &strEncode("<li>FEEDログファイルのパス : OK! → $feedlog\n");
			print &strEncode("<li>FEEDログファイルのパーミッション : OK!\n");
		} else {
			print &strEncode("<li>FEEDログファイルのパスが設定されていません：NG!!\n");
		}
	};

	print "</ul><ul>";

	$printString = <<EOM;
<li>init.cgiバージョン: $ver <br>起動されたCGIバージョン: $sver
</ul>

</td></tr></table>
<p>
EOM
print &strEncode($printString);

	&setting;
}

# 掲示板のパラメータ表示をサブルーチンに変更
sub setting {

	my $hothour = $hot / 3600;
	$maxdata = $maxdata / 1000;

	my $printString = <<EOM;
<table bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2"><td $bgclass align="left" bgcolor="$col1">
	<font color="$col6"><b>この会議室の設定内容</b></font>
</td></tr></table>
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2">
  <td align="left" bgcolor="$col2" nowrap><b>項目</b></td>
  <td align="left" bgcolor="$col2" nowrap><b>設定値</b></td>
  <td align="left" bgcolor="$col2" nowrap><b>備考</b></td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >1スレッドあたりの最大記事数</td>
  <td align="left" bgcolor="$col2" nowrap>$m_max コメント</td>
  <td align="left" bgcolor="$col2" nowrap>レス数がこれを越えると過去ログに移行します</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >トップ1頁に表示するスレッド数</td>
  <td align="left" bgcolor="$col2" nowrap>$menu1 / $fmenu1</td>
  <td align="left" bgcolor="$col2" nowrap>Patio形式 / Forum形式各々のトップページに表示されるスレッド数</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >原稿ログのスレッド数</td>
  <td align="left" bgcolor="$col2" nowrap>$i_max スレッド</td>
  <td align="left" bgcolor="$col2" nowrap>スレッド数がこれを越えると過去ログに移行します</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >過去ログのスレッド数</td>
  <td align="left" bgcolor="$col2" nowrap>$p_max スレッド</td>
  <td align="left" bgcolor="$col2" nowrap>過去ログのスレッド数がこれを越えるとスレッドは削除されます</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >連続投稿間隔</td>
  <td align="left" bgcolor="$col2" nowrap>$wait 秒</td>
  <td align="left" bgcolor="$col2" nowrap>連続投稿はこの時間以上待ってから行なって下さい 0=無制限</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >日本語チェック</td>
  <td align="left" bgcolor="$col2" nowrap>$jp_wd</td>
  <td align="left" bgcolor="$col2" nowrap>書き込みに日本語が含まれるか判定します 0=無効 1=有効</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >URL数制限</td>
  <td align="left" bgcolor="$col2" nowrap>$urlnum 個まで</td>
  <td align="left" bgcolor="$col2" nowrap>投稿中に含めることが許可されているURLの数 0=URL記述不可、-1=無制限</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >投稿できる文字数</td>
  <td align="left" bgcolor="$col2" nowrap>$max_msg 文字</td>
  <td align="left" bgcolor="$col2" nowrap>全角換算</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >投稿できるデータサイズ</td>
  <td align="left" bgcolor="$col2" nowrap>$maxdata KB</td>
  <td align="left" bgcolor="$col2" nowrap>記事、添付画像･添付ファイルを含んだ最大のデータサイズ (Ｋバイト)</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >投稿キー許容時間</td>
  <td align="left" bgcolor="$col2" nowrap>$pcp_time 分</td>
  <td align="left" bgcolor="$col2" nowrap>フォームを表示させてから投稿するまでの時間制限</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >新着表示時間</td>
  <td align="left" bgcolor="$col2" nowrap>$hothour 時間</td>
  <td align="left" bgcolor="$col2" nowrap>新着記事の $newmark マークが表示される時間</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >管理者によるパスワードクリア</td>
  <td align="left" bgcolor="$col2" nowrap>$clearpass</td>
  <td align="left" bgcolor="$col2">管理者が編集した場合、ユーザーのパスワードをクリアするか 0=維持する 1=クリアする（ユーザーが編集できなくなる）</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >レスお知らせメール</td>
  <td align="left" bgcolor="$col2" nowrap>$mailnotify</td>
  <td align="left" bgcolor="$col2">レスがあったときにお知らせ 0=しない 1=スレッドを立てた人のみ 2=コメントした人も含め全員 3=スレ主とレス先</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >新規スレッド作成制限</td>
  <td align="left" bgcolor="$col2" nowrap>$createonlyadmin</td>
  <td align="left" bgcolor="$col2" nowrap> 0=誰でも作成できる 1=管理者のみ（ユーザーはスレッドを作成できない）</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >BBCode使用の可否</td>
  <td align="left" bgcolor="$col2" nowrap>$bbcode</td>
  <td align="left" bgcolor="$col2" nowrap>記事の題名、名前、本文記事内にBBCodeタグの使用ができるか 1=できる、0=出来ない</td>
</tr>
EOM

	if ($feed) {
		$printString .= <<EOM;
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >RSSフィード出力件数</td>
  <td align="left" bgcolor="$col2" nowrap>$feed_num / $t_rss_num</td>
  <td align="left" bgcolor="$col2" nowrap>トップページ / スレッド閲覧ページ各々のFEEDに出力される最新記事の数</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >FEEDログの記録件数</td>
  <td align="left" bgcolor="$col2" nowrap>$log_length</td>
  <td align="left" bgcolor="$col2" nowrap>この件数を超えた過去の記事はログから削除されます</td>
</tr>
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >FEEDログ記事本文の文字数</td>
  <td align="left" bgcolor="$col2" nowrap>$len</td>
  <td align="left" bgcolor="$col2" nowrap>記事中の引用文・BBCodeタグを削除した後の文字数</td>
</tr>
EOM
		my $temp = '';
		my $num = 0;
		if ($rss1patiofile) { $num++; $temp .= "<li>$rss1patiourl\n"; }
		if ($rss2patiofile) { $num++; $temp .= "<li>$rss2patiourl\n"; }
		if ($atompatiofile) { $num++; $temp .= "<li>$atompatiourl\n"; }
		if ($rss1forumfile) { $num++; $temp .= "<li>$rss1forumurl\n"; }
		if ($rss2forumfile) { $num++; $temp .= "<li>$rss2forumurl\n"; }
		if ($atomforumfile) { $num++; $temp .= "<li>$atomforumurl\n"; }
			
		$printString .= <<EOM;
<tr bgcolor="$col1">
  <td align="left" bgcolor="$col2" >FEEDファイルの個数とURL</td>
  <td align="left" bgcolor="$col2" nowrap>$num</td>
  <td align="left" bgcolor="$col2" nowrap><ul>$temp</ul></td>
</tr>
EOM
	}

	$printString .= <<EOM;
</table>
<br>
<!-- 著作権表\示部・削除禁止 ($ver) -->
<span class="s1">
- <a href="http://www.kent-web.com/" target="_top">Web Patio</a> -
 <a href="http://kirishima.cc/patio/" target="_top">きりしま式</a> -
 <a href="http://jyosui.xrea.jp/" target="_top">RSS/Atom</a> -
 <a href="http://vmorita.com/bbs/patio/" target="_top">スガラボット版</a> -
</span></div>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<EOM;
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}


1;

