#┌─────────────────────────────────
#│ [ WebPatio ]
#│ find.pl - 2007/04/09
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#└─────────────────────────────────
# 2007.05.10 本文も検索対象に

use utf8;
#use URI::Escape;

$sver = 'v1.43';
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義ヘッダー対応のコラム背景画像クラスを追加
# 2009/07/05 CGIスクリプトをUnicode記述に変更。HTML入出力とログファイルの文字コード(utf8,sjis,euc,jis)を設定可能
# v1.10 携帯電話からのアクセスを可能とするため表示内容を修正 （2008/12/05 スガラボット修正)
#-------------------------------------------------
#  ワード検索
#-------------------------------------------------
sub find {

	my ($view) = @_;
	if ($view eq 'forumview' || $in{'view'} eq 'forum') { $view = 'forumview'; }
	else { $view = 'patioview'; }

	our($target,$alarm,$next,$back,$enwd,@log1,@log2,@log3,@wd,$readshtml0,$hexwd);
	$readshtml0 = $readshtml;

# 携帯からのアクセスかどうかを判定
	# PCからアクセスした時。($ua=0 はPC 1～6は携帯)
	if (!$ua && $treeforum)
	{
		$tree = 1;
		$width = "width=\"95%\"";
		$colspan = "colspan=\"6\"";
	}
	# 携帯からアクセスした時
	else {
		$tree = 0;
		$width = "width=\"100%\"";
		$colspan = "colspan=\"5\"";
	}

my $keyword;
if (!$in{'word'}) {
	my @hexword = split(/[\+\s]+/, $in{'hexwd'});
	my @temp = @hexword;
	my $plus = '';
	foreach ( @temp ) {
		$_ = pack('H*', $_);
		$_ = &strDecode($_, $encode);
		push (@wd, $_);
		$keyword .= $plus . $_;
		$plus = ' ';
	}
	$in{'word'} = $keyword;
} else {
	@wd = split(/[\s　]+/, $in{'word'});
}

# デバッグプリント
#	my $degubstr;
#	foreach (@wd) { $debugstr .= $_ . '+'; }
#	&error("Debug：:検索語の確認　\$in{'hexwd'}=$in{'hexwd'}, \@word=$debugstr, \$hexwd=$hexwd");

	&header();

	$printString = <<"EOM";
<div align="center">
<form action="$bbscgi" method="POST">
<input type="hidden" name="mode" value="find">
<table $width><tr><td align="right" nowrap>
<a href="$bbscgi">トップページ</a> &gt; <b>ワード検索</b>
</td></tr></table>
<table border=0 bgcolor="$col1" cellspacing=1 cellpadding=5 $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/glass.gif" align="middle">
&nbsp;<b>ワード検索</b></td>
</tr>
<tr bgcolor="$col2"><td bgcolor="$col2" align="left">
キーワード <input type="text" name="word" size="38" value="$in{'word'}"> &nbsp;
スレッド選択条件 <select name="op">
EOM
print &strEncode($printString);

	foreach ("AND", "OR") {
		if ($in{'op'} eq $_) {
			print "<option value=\"$_\" selected>$_\n";
		} else {
			print "<option value=\"$_\">$_\n";
		}
	}
	print &strEncode("</select> &nbsp; 表示 <select name=vw>\n");
	foreach (10,15,20,25) {
		if ($in{'vw'} == $_) {
			print &strEncode("<option value=\"$_\" selected>${_}件\n");
		} else {
			print &strEncode("<option value=\"$_\">${_}件\n");
		}
	}
	print &strEncode("</select><br>検索範囲 ");

	if ($in{'log'} eq "") { $in{'log'} = 0; }
	@log1 = ($nowfile, $pastfile);
	@log2 = ("現行ログ", "過去ログ");
	@log3 = ("view", "past");
	foreach (0,1) {
		if ($in{'log'} == $_) {
			print &strEncode("<input type=radio name=log value=\"$_\" checked>$log2[$_]\n");
		} else {
			print &strEncode("<input type=radio name=log value=\"$_\">$log2[$_]\n");
		}
	}
	print &strEncode("<br>検索項目 ");

	$in{'s'} = $in{'n'} = $in{'c'} = 1;
	my @select;
	my $param;
	if (defined($in{'select'})) {
		@select = split(/\0/, $in{'select'});
		$in{'s'} = $in{'n'} = $in{'c'} = 0;
		foreach ( @select ) {
			$param .= $_ . ', ';
			if ($_ eq 's') { $in{'s'} = 1; }
			elsif ($_ eq 'n') { $in{'n'} = 1; }
			elsif ($_ eq 'c') { $in{'c'} = 1; }
		}
	}
	if ($in{'s'} == 1) {
		print &strEncode("<input type=checkbox name=select value=\"s\" checked>トピックス\n");
	} else {
		print &strEncode("<input type=checkbox name=select value=\"s\">トピックス\n");
	}
	if ($in{'n'} == 1) {
		print &strEncode("<input type=checkbox name=select value=\"n\" checked>名前\n");
	} else {
		print &strEncode("<input type=checkbox name=select value=\"n\">名前\n");
	}
	if ($in{'c'} == 1) {
		print &strEncode("<input type=checkbox name=select value=\"c\" checked>本文\n");
	} else {
		print &strEncode("<input type=checkbox name=select value=\"c\">本文\n");
	}

	if (!$in{'kijiop'}) { $in{'kijiop'} = $in{'op'}; }

	# forum形式の場合、検索実行ボタンの前に各記事のヒット表示を選択する条件を入れる
	if ($view eq 'forumview') {
		print &strEncode("<br>スレッド検索条件がANDのときスレッド内各記事のハイライト方法 (ANDなら一記事内に全ての検索語を含む) ");
		foreach ("AND", "OR") {
			if ($in{'kijiop'} eq $_) {
				print "<input type=\"radio\" name=\"kijiop\" value=\"$_\" checked>$_\n";
			} else {
				print "<input type=\"radio\" name=\"kijiop\" value=\"$_\">$_\n";
			}
		}
	}

		$printString = <<EOM;
&nbsp;&nbsp;<input type="submit" value="検索実行">
</td></tr></table></form>
EOM
print &strEncode($printString);

	# 既に検索パラメータが入力済みであれば検索実行
	if ($in{'word'} && ($in{'s'} || $in{'n'} || $in{'c'})) {

		# アラーム数定義
		$alarm = int($m_max*0.9);

		# 以下のコードはSJISの全角空白のためスキップ （2009/07/19 スガラボット修正)
#		$in{'word'} =~ s/\x81\x40/ /g;

		# 検索された文字列を記録
		chomp($in{'word'});
		if ($srchlog) {
			open(OUT,">>$srchlog") || &error("Write Error: $srchlog");
			print OUT &strEncode("$in{'word'}\t$date\t$time\t$host\n", $logchar);
			close(OUT);
		}

#		@wd = split(/[\s　]+/, $in{'word'});
		$kijiop = "&kijiop=$in{'kijiop'}";

		# 次のページにリンクを張るときの検索語パラメータをURLエンコード
		$enwd = &strEncode($in{'word'});
		$enwd = &url_enc($enwd);

		# 検索語をHex変換して持ち回るとき
		$hexwd = '';
		my $plus = '';
		my @tempwd = @wd;
		foreach ( @tempwd ) {
			$_ = &strEncode($_);
			$hexwd .= $plus . unpack('H*', $_);
			$plus = '+';
		}

# デバッグプリント
#	my $degubstr;
#	foreach (@wd) { $debugstr .= $_ . '+'; }
#	&error("Debug：:検索語の確認　\$in{'hexwd'}=$in{'hexwd'}, \@word=$debugstr, \$hexwd=$hexwd");

		# ヒットしたときの閲覧ページへのリンクを定義
#		my $linkparam = "&word=$enwd&vw=$in{'vw'}&op=$in{'op'}&log=$in{'log'}&s=$in{'s'}&n=$in{'n'}&c=$in{'c'}$kijiop";
		my $linkparam0 = "hexwd=$hexwd&vw=$in{'vw'}&op=$in{'op'}&log=$in{'log'}&s=$in{'s'}&n=$in{'n'}&c=$in{'c'}$kijiop";
		my $linkparam = '&' . $linkparam0;
		$readcgi .= $linkparam;
		$readshtml .= $linkparam;
		$bbscgi .= '&mode=find' . $linkparam;
		$patioshtml .= "&$linkparam0";
		$forumshtml .= "&$linkparam0";
		$bbsshtml .= "&$linkparam0";
#		if ($ua) {
#			$readshtml = $readcgi;
#		}

		# patio/forum 形式の表示を選択
		&$view;
		
		$printString = <<EOM;
<table border="0" cellspacing="1" cellpadding="4" $width>
<tr><td  align="left">
 &nbsp;<a href="$bbsshtml">トップページ</a>
 &nbsp;<a href="$readshtml0&mode=form&tree=1">新規スレッド作成</a>
</td></tr></table>
EOM
print &strEncode($printString);

	}

	print "</div>\n";
	&pr_footer;
	print "</body></html>\n";
	exit;
}

#---------------------------------------
# 従来からのpatio トップページによる表示
#---------------------------------------

sub patioview {

	# ツリー表示利用の手引きの記述(前の2行から後の5行)を追加 (20080301 スガラボット修正)
	if ($tree) {
		$printString = <<EOM;
<Table border=0 cellspacing=0 cellpadding=3 $width>
<Tr><Td align="left">
<li> <img src=\"$imgurl/right_btn.gif\" alt="タイトル一覧"> をクリックするとスレッド内発言のタイトル一覧を表示します。
<li> 「ツリー表示」欄の<img src=\"$imgurl/tree.gif\">をクリックするとトピックス毎に
Forum形式で記事の参照関係が${strong1}ツリー表示${strong2}されます
</Td></Tr></Table>
EOM
print &strEncode($printString);
	}
	else { print "<p>"; }

	print <<EOM;
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="4" $width>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="20"><b>一覧</b></td>
  <td bgcolor="$col2" width="20"><b>閲覧</b></td>
EOM
	if ($tree) {
		$printString = <<EOM;
  <td bgcolor="$col2" nowrap><b>ツリー<br>表示</b></td>
EOM
print &strEncode($printString);
	}

	$printString = <<EOM;
  <td bgcolor="$col2" width="70%" nowrap><b>トピックス</b></td>
  <td bgcolor="$col2" nowrap><b>作成者</b></td>
  <td bgcolor="$col2" nowrap><b>返信</b></td>
  <td bgcolor="$col2" nowrap><b>閲覧数</b></td>
EOM
print &strEncode($printString);

	my $i = 0;
	open(IN,"$log1[$in{'log'}]") || &error("Open Error: $log1[$in{'log'}]");
#	$top = <IN> if (!$in{'log'});
	my $top = &lineDecode(IN) if (!$in{'log'});

	local($no,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime);
	while ( $_ = &lineDecode(IN) ) {
		my $target = '';
		my ($no,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime) = split(/<>/);

		$target .= $sub if ($in{'s'});
#		$target .= $nam if ($in{'n'});

		# 参照カウンタ読み込み
		my $count;
		open(NO,"$logdir/$no.dat") || &error("$no.datがみつかりません");
		$data = <NO>;
		close(NO);
		($count) = split(/:/, $data);

		# スレッド読み込み
		open(KOBETU,"$logdir/$no.cgi");
#		$top2 = <KOBETU>;
		$top2 = &lineDecode(KOBETU);

		my ($num2,$sub2,$nam2,$com2,$upl2,$upl3,$upl4,$sub0);
		my $j = 0;
		while ( $_ = &lineDecode(KOBETU) ) {
			($num2,$sub2,$nam2,undef,$com2,undef,undef,undef,undef,undef,undef,undef,$upl2,$upl3,$upl4,undef) = split(/<>/);
			$sub0 = $sub2 if (!$j);
			$target .= $sub2 if ($in{'s'}) ;
			$target .= $nam2 if ($in{'n'}) ;
			if ($in{'c'}) {
				$target .= $com2;
				$target .= $upl2 . $upl3. $upl4;
			}
			$j++;
		}
		close(KOBETU);

		my $flg = 0;
		foreach $wd (@wd) {
#			if (index($target,$wd) >= 0) {
			if (&search($target,$wd)) {
				$flg = 1;
				if ($in{'op'} eq 'OR') { last; }
			} else {
				if ($in{'op'} eq 'AND') { $flg = 0; last; }
			}
		}
		if ($flg) {
			$i++;
			if ($i < $p + 1) { next; }
			if ($i > $p + $in{'vw'}) { next; }

			# アイコン定義
			if ($key eq '0') { $icon =  'fold3.gif'; }
			elsif ($key == 2) { $icon = 'look.gif'; }
			elsif ($res >= $alarm) { $icon = 'fold5.gif'; }
			elsif (time < $restime + $hot) { $icon = 'foldnew.gif'; }
			elsif ($upl) { $icon = 'fold6.gif'; }
			else { $icon = 'fold1.gif'; }

			# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
			if ($patio_trip) {
				$nam =~ s/◆.+//g;
				$na2 =~ s/◆.+//g;
			}
		
			# bbcode を展開
			$sub = &$titlebb($sub);	
			$sub2 = &$titlebb($sub2);	
			$nam = &$titlebb($nam);	
			$ressub = &$titlebb($ressub);	
			$na2 = &$titlebb($na2);	

			# 検索語をハイライト
			$sub = &highlight($sub, \@wd) if ($in{'s'});
			$sub2 = &highlight($sub2, \@wd) if ($in{'s'});
			$ressub = &highlight($ressub, \@wd) if ($in{'n'});
			$nam = &highlight($nam, \@wd) if ($in{'n'});
			$na2 = &highlight($na2, \@wd) if ($in{'n'});

			print "<tr bgcolor=\"$col1\"><th bgcolor=\"$col2\">";
			print "<a href=\"$patioshtml&view=thread&no=$no&tree=0\"><img src=\"$imgurl/right_btn.gif\" border=\"0\"></a></th>\n";
			print "<th bgcolor=\"$col2\"><a href=\"$readshtml&mode=$log3[$in{'log'}]&no=$no&tree=0\"><img src=\"$imgurl/$icon\" border=\"0\"></a></th>\n";

			# ツリー表示のため以下の3行を追加 (20080319 スガラボット修正)
			if ($tree) {
				print "<td bgcolor=\"$col2\" align=\"center\"><a href=\"$readshtml&$mode=$log3[$in{'log'}]&tree=1&no=$no\"><img src=\"$imgurl/tree.gif\" border=\"0\"></a>\n";
				print "<a href=\"$readshtml&$mode=$log3[$in{'log'}]&tree=1&no=$no&l=rev\"> ";
				print &strEncode("<img src=\"$imgurl/treerev2.gif\" border=\"0\" alt=\"●\"></a></td>\n");
			}
			if (time >= $restime + $hot) { ($st1, $st2, $newdisp) = ''; }			#フラグをリセット
			else {
				$st1 = "<b>";
				$st2 = "</b>";
				$newdisp = $newmark;
			}

			print "<td bgcolor=\"$col2\" width=\"70%\" align=\"left\">\n";
			# ツリー表示のため以下の3行を追加
			if ($tree) {
				print "<a href=\"$readshtml&mode=$log3[$in{'log'}]$treeflg&no=$no\">";
				print &strEncode("[$no] $st1$sub$st2</a> $newdisp\n");
			} else {
				print "<a href=\"$readshtml&mode=$log3[$in{'log'}]$treeflg&no=$no\">";
				print &strEncode("[$no] $st1$sub$st2</a> $newdisp\n");
			}
			# 最新レスをクリックしたときの表示を最新レスを先頭にツリーを逆順表示する
			print &strEncode("<br><font size=\"+1\">　</font><span class=s1>&nbsp;&nbsp;&nbsp;\n");
			if ($ressub) {
				print "<a href=\"$readshtml&$treeflg&mode=$log3[$in{'log'}]&no=$no&l=rev\">";
				print &strEncode("<img src=\"$imgurl/upbutton2.gif\" border=\"0\" alt=\"▲\"></a> \n");
				print "<a href=\"$readshtml&$treeflg&mode=$log3[$in{'log'}]&no=$no&l=new\">";
				print &strEncode("$st1$ressub$st2</a>\n");
			}
			print &strEncode(" by $na2 $date</span></td>");
			print &strEncode("<td bgcolor=\"$col2\" align=\"left\" nowrap>$nam</td>\n");
			print "<td bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\">$res</td>\n";
			print "<td bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\">$count</td>\n";
			print "</tr>\n";
		}
	}
	close(IN);

	print "<tr bgcolor=\"$col1\"><td bgcolor=\"$col2\"><br></td>";
	if ($tree) {
		print "<td bgcolor=\"$col2\"></td>";
	}
	print &strEncode("<td bgcolor=\"$col2\" colspan=\"5\" align=\"left\">検索結果：<b>$i</b>件 &nbsp;&nbsp;");

	$next = $p + $in{'vw'};
	$back = $p - $in{'vw'};

	if ($back >= 0) {
		print "[<a href=\"$bbscgi&p=$back\">";
		print &strEncode("前の$in{'vw'}件</a>]\n");
	}
	if ($next < $i) {
		print "[<a href=\"$bbscgi&p=$next\">";
		print &strEncode("次の$in{'vw'}件</a>]\n");
	}

	print "</td></tr></table>\n";
	return;
}

#---------------------------------------
# forum 形式のトップページによる表示
#---------------------------------------

sub forumview {

	# 携帯電話からのアクセスの場合はツリー表示の説明を入れない (2008/12/08 スガラボット修正)
	if (!$ua) {
		$note_msg = "<LI>スレッド先頭部の <img src=\"$imgurl/tree.gif\"> または <img src=\"$imgurl/fold1.gif\"> をクリックするとスレッド内の全記事を表示します。(<img src=\"$imgurl/tree.gif\"> はツリー表示)\n" .
					"<LI>記事先頭の <font color=\"green\">▼ △</font>をクリックするとスレッド内の関連する発言をその発言から (<font color=\"green\">\n" .
					"▼</font>は下、<font color=\"green\">△</font>は上) へツリー表示します。<font size=\"+1\">　</font>" .
					"<LI>スレッド最新記事の後にある <img src=\"$imgurl/treerev2.gif\"> または <img src=\"$imgurl/upbutton1.gif\"> をクリックするとスレッド内の全記事を降順に表示します。(<img src=\"$imgurl/treerev2.gif\"> はツリー表示)</td>\n";
	}
	else {
		$note_msg = "<LI>スレッド先頭部の <img src=\"$imgurl/fold1.gif\"> をクリックするとスレッド内の全記事を順に表示します</td>\n";
	}

	$printString = <<"EOM";
<Table border=\"0\" cellspacing=\"5\" cellpadding=\"0\" $width>
<tr><td align="left">$note_msg</td></tr></table>\n
EOM
print &strEncode($printString);

	# テーブル幅は携帯とPCで異なるのでキャッシュファイルには書き出さない
	print "<p><Table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width>\n";

	# 最初の行セット
	my $init = 1;

	my $i = 0;
	my $m = 0;		# ヒットしたスレッド数
	our $hit = 0;
	open(TP, "$log1[$in{'log'}]") || &error("Open Error: $log1[$in{'log'}]");
	@tp = &arrayDecode(TP);
	close(TP);
		
	my $top;
	if (!$in{'log'}) { $top = shift(@tp); }
	my @count;

	for ($i = 0; $tp[$i]; $i++) {

		$target = '';
		local($num,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime) = split(/<>/, $tp[$i]);

		$target .= $sub if ($in{'s'});
		$target .= $nam if ($in{'n'});

		# スレッドタイトルとレス親の題名を分離する （2009/05/01 スガラボット修正)
		$tsub = $sub;

		$tno[$i] = $num;

		# 参照カウンタ読み込み
		open(NO,"$logdir/$num.dat");
		$data = <NO>;
		close(NO);
		($count[$i]) = split(/:/, $data);

		# スレッド読み込み
		open(IN, "$logdir/$num.cgi") || &error("Open Error: $num.cgi");
#		@log = <IN>;
		my @log = &arrayDecode(IN);
    	close(IN);
    
		$top1 = $log[0];
		($no,$sub,$res,$key) = split(/<>/, $top1);
    
		# ツリー構造のリンクリストを作成するためトピックスのログファイルを一度全部読み込む。
		$no[0] = 0;
		$j = 1;
		for ($line = 0; $log[$j]; $line++) {
			chomp($log[$j]);
			($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
					$myid[$line],$tim[$line],$upl[1][$line],$upl[2][$line],$upl[3][$line],$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $log[$j]);
			$prnt[$line] = $resto[$line];

			$target .= $sub[$line] if ($in{'s'}) ;
			$target .= $nam[$line] if ($in{'n'}) ;
			if ($in{'c'}) {
				$target .= $com[$line];
				$target .= $up[l][$line] . $upl[2][$line] . $upl[3][$line];
			}

			$j++;
		}
#		$num = $line;
		$nofline = $line;

		$flg = 0;
		foreach $wd (@wd) {
#			if (index($target,$wd) >= 0) {
			if (&search($target,$wd)) {
				$flg = 1;
				if ($in{'op'} eq 'OR') { last; }
			} else {
				if ($in{'op'} eq 'AND') { $flg = 0; last; }
			}
		}

		# 検索語がヒットしなかったら何も表示しないで次のスレッドへ
		our ($tsubstr1, $tsubstr2);
		if ($flg) {
			# ヒットしたスレッド数をインクリメント
			$m++;
			if ($m < $p + 1) { next; }
			if ($m > $p + $in{'vw'}) { next; }

			# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
			$sub[0] = &$titlebb($sub[0]);	
			$nam[0] = &$titlebb($nam[0]);	
			$tsub = &$titlebb($tsub);

			$tsub = &highlight($tsub, \@wd) if ($in{'s'});
			$sub[0] = &highlight($sub[0], \@wd) if ($in{'s'});
			$nam[0] = &highlight($nam[0], \@wd) if ($in{'n'});

			# レスハイライトのタグをセット
			$tsubstr1 = $strong1b;
			$tsubstr2 = $strong2b;

			# ヒットしたらそのスレッドのindexをツリー表示

# ツリー構造のインデックス・リストを作成
#	prnt: 親ノード (parent node)
#	chid: 子ノード (child node)
#	next: 次ノード (兄弟リンクのnext node)
#	prev: 前ノード (兄弟リンクのprevious node)

			# スレッドのツリー表示がずれるのを修正するため、ツリーリストを作成するときはその都度@lineno関数をクリアする (20081015 スガラボット修正)
			@lineno = ();
			$prnt[0] = 0;
			$chid[0] = 0;

			for ($line = 0; $line < $nofline; $line++) {
				&lst_cre($line, $prnt[$line], $no[$line]);
			}

			if (!$init) {
				print "<tr><td>&nbsp;</td></tr>";
			}
			$init = 0;

			print  "<Tr><td nowrap align=\"left\">\n";

######### デバッグ用にtree テーブルの表示
#			print " line &nbsp;&nbsp;no prnt chid next prev<br>\n";
#			for ($line = 0; $line < $nofline; $line++) {
#			    print &strEncode(sprintf("%4d,%4d,%4d,%4d,%4d,%4d,%50s<br>\n", $line, $no[$line],
#			        $prnt[$line], $chid[$line], $next[$line], $prev[$line], $sub[$line]));
#			}
#			print "<br>\n";
#   
#			# デバッグ用にtree 行番号逆引きテーブル表示
#			$ln = $no[-1] + 1;
#			for ($line = 0; $line < $ln; $line++) {
#			    print sprintf("%4d,%4d<br>\n", $line, $lineno[$line]);
#			}
#			print "\n";
    
			# スレッドの状態を表示 (20081025 スガラボット修正)
			if ($key eq '0') {
				print "&nbsp;&nbsp;&nbsp;<img src=\"$imgurl/alarm.gif\"> ";
				print &strEncode("このスレッドは<b>ロック</b>されています。");
				print &strEncode("記事の閲覧のみとなります。");
				print "<br>\n";
    
			} elsif ($key == 2) {
				print "&nbsp;&nbsp;&nbsp;<img src=\"$imgurl/alarm.gif\"> ";
				print &strEncode("このスレッドは<b>管理者からのメッセージ</b>です。");
			print &strEncode("記事の閲覧のみとなります。");
			print "<br>\n";

			} elsif ($key eq '4') {
				print "&nbsp;&nbsp;&nbsp;<img src=\"$imgurl/alarm.gif\"> ";
				print &strEncode("このスレッドは<b>管理者によりロック</b>されています。");
				print &strEncode("記事の閲覧のみとなります。");
				print "<br>\n";

			} elsif ($alarm <= $res) {
				print &strEncode("&nbsp;&nbsp;&nbsp;<img src=\"$imgurl/alarm.gif\"> ");
				print &strEncode("返信記事数が<b>$res</b>件あります。");
				print &strEncode("<b>$m_max</b>件を超えると書き込みができなくなります。");
				print "><br>\n";
			}
        
			# アイコン定義
			if ($key eq '0' || $key eq '4') { $icon = 'fold3.gif'; }
			elsif ($key eq '3') { $icon = 'fold4.gif'; }
			elsif ($key eq '2') { $icon = 'look.gif'; }
			elsif ($res >= $alarm) { $icon = 'fold5.gif'; }
#			elsif ($upl) { $icon = 'fold6.gif'; }
			else { $icon = 'fold1.gif'; }

			# 添付ファイルのアイコン定義
			$res_icon = '';
			foreach $k (1 .. 3) 
			{
				local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][0]);
				if ($ex) { $res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> "; last;}
			}

			# この記事に検索語が含まれるかをチェック
			my $ktarget = '';
			$ktarget = $sub if ($in{'s'});
			$ktarget .= $nam if ($in{'n'});
			$ktarget .= $sub[0] if ($in{'s'}) ;
			$ktarget .= $nam[0] if ($in{'n'}) ;
			if ($in{'c'}) {
				$ktarget .= $com[0];
				$ktarget .= $up[l][0] . $upl[2][0] . $upl[3][0];
			}
			$flg = 0;
			foreach $wd (@wd) {
#				if (index($ktarget,$wd) >= 0) {
				if (&search($ktarget,$wd)) {
					$flg = 1;
					if ($in{'kijiop'} eq 'OR') { last; }
				} else {
					if ($in{'kijiop'} eq 'AND') { $flg = 0; last; }
				}
			}

			my ($st1, $st2);
			if ($flg) {

				$st1 = $strong1b;
				$st2 = $strong2b;
			}

			# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
			if ($patio_trip) {
				$nam[0] =~ s/[◆◇].+//g;
			}
		
			#スレッドタイトルとレス親題名を分離したことに因る処理
			local ($sub1, $sub2);
			if ($sub[0] ne $tsub) {
				$sub_dif = 1;
				$sub1 = "&nbsp;&nbsp;<b>${tsubst1}スレッド $tno[$i]: $tsub$tsubst2</b> &nbsp;<br><img src=\"$imgurl/spacer_h4.gif\"><br>";
				$sub2 = " <b>No.0 &nbsp;</b>";
			} else {
				$sub2 = "<b>${tsubst1}スレッド $tno[$i]:$tsubst2</b>";
			}

			# スレッドの親記事を表示
			print &strEncode($sub1);

			if (!$ua) {
				print "&nbsp;&nbsp;&nbsp;<a href=\"$readshtml&tree=1&no=$tno[$i]&l=all\"><img src=\"$imgurl/tree.gif\" border=\"0\"></a>\n";
				print " <a href=\"$readshtml&no=$tno[$i]\"><img src=\"$imgurl/$icon\" border=\"0\"></a>";
				print &strEncode(" $st1$sub2 ［$res_icon");
				print "<a href=\"$readshtml&tree=1&no=$tno[$i]&l=0\">";
				print &strEncode("$sub[0]</a>］&nbsp;<b>$nam[0] </b> &nbsp;$dat[0]$st2 \n");
			} else {
				print "&nbsp;&nbsp;&nbsp;<a href=\"$readshtml&no=$tno[$i]\"><img src=\"$imgurl/$icon\" border=\"0\"></a>\n";
				print &strEncode(" $st1$sub2 ［$res_icon");
				print "<a href=\"$readshtml&tree=1&no=$tno[$i]&l=0\">";
				print &strEncode("$sub[0]</a>］&nbsp;<b>$nam[0] </b> &nbsp;$dat[0]$st2 \n");
			}
			if (time < $tim[0] + $hot) { print "<font color=\"#FF3300\"> <b>new!</b></font>"; }
			print &strEncode(" &nbsp;&nbsp;閲覧数: $count[$i] <br>\n");

#			$pre = '　';
#			our $pre1a = '├';
#			our $pre1b = '└';
#			our $pre2a = '│';
#			our $pre2b = '　';

			our $pre = "<img src=\"$imgurl/blank.gif\">";
			our $pre1a = "<img src=\"$imgurl/branch.gif\">";
			our $pre1b = "<img src=\"$imgurl/next.gif\">";
			our $pre2a = "<img src=\"$imgurl/down.gif\">";
			our $pre2b = "<img src=\"$imgurl/blank.gif\">";

			# スレッドを階層表示
			if ($chid[0]) {
				&lst_find($chid[0], $pre);
			}
			print  "</td></tr>\n";
			
		}
	}

	print "<tr><td>&nbsp;</td></tr></table>";

	# 検索結果行の表示
	print "<table border=\"0\" bgcolor=\"$col1\" cellspacing=\"1\" cellpadding=\"4\" $width>";
	print "<tr bgcolor=\"$col2\"><td bgcolor=\"$col2\" align=\"left\">";
	print &strEncode(" &nbsp;&nbsp; <b>検索結果: </b> 合計 <b>$m</b> スレッド、このページで <b>$hit</b> 件の記事がヒットしました&nbsp;&nbsp;");

	$next = $p + $in{'vw'};
	$back = $p - $in{'vw'};

	if ($back >= 0) {
		print "[<a href=\"$bbscgi&view=forum&p=$back\">";
		print &strEncode("前の$in{'vw'}件</a>]\n");
	}
	if ($next < $m) {
		print "[<a href=\"$bbscgi&view=forum&p=$next\">";
		print &strEncode("次の$in{'vw'}件</a>]\n");
	}
	print  "</td></tr></table>\n";

	return;
}

#----------------------------------------------------
# ツリー構造のポインターリストを印刷するサブルーチン
#----------------------------------------------------

#	$pre = '';
#	$pre1a = '├';
#	$pre1b = '└';
#	$pre2a = '│';
#	$pre2b = '　';

sub lst_find {
    my ($idx, $pre) = @_;			# 引数はデータの行番号とプレフィックス文字列
    my ($i, $link);

#printf("lst_dsp(%d)\n", $idx);

	$i = $idx;
	do {
		if ($next[$i] == $chid[$prnt[$i]]) {
			# 自分の次ノードが長男のポインタと同じなら最後のノード
			$pre1 = $pre.$pre1b;
			$pre2 = $pre.$pre2b;
		} else {
			# 最後以外のノード
			$pre1 = $pre.$pre1a;
			$pre2 = $pre.$pre2a;
		}
#		printf("%-20s %-11s %-10s\n",
#			$pre1.$data[$i], $date[$i], $user[$i]);

		# この記事に検索語が含まれるかをチェック
		my $ktarget = '';
		$ktarget = $sub[$i] if ($in{'s'}) ;
		$ktarget .= $nam[$i] if ($in{'n'}) ;
		if ($in{'c'}) {
			$ktarget .= $com[$i];
			$ktarget .= $up[l][$i] . $upl[2][$i] . $upl[3][$i];
		}
		$flg = 0;
		foreach $wd (@wd) {
#			if (index($ktarget,$wd) >= 0) {
			if (&search($ktarget,$wd)) {
				$flg = 1;
				if ($in{'kijiop'} eq 'OR') { last; }
			} else {
				if ($in{'kijiop'} eq 'AND') { $flg = 0; last; }
			}
		}

		# もしこのレスに検索語が含まれていたらそのレスを強調表示する
		my ($st1, $st2);
		if ($flg) {
			$hit++;

			$st1 = $strong1b;
			$st2 = $strong2b;
		} else {
			$st1 = ''; $st2 = '';
		}

		# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
		if ($patio_trip) {
			$nam[$i] =~ s/[◆◇].+//g;
		}
		
		# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
		$sub[$i] = &$titlebb($sub[$i]);	
		$nam[$i] = &$titlebb($nam[$i]);	

		# タイトルと名前に検索語のハイライト表示を追加 （2009/07/19 スガラボット修正)
		$sub[$i] = &highlight($sub[$i], \@wd) if ($in{'s'});
		$nam[$i] = &highlight($nam[$i], \@wd) if ($in{'n'});

		# 添付ファイルのアイコン定義
		$res_icon = '';
		foreach $k (1 .. 3) 
		{
			local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][$i]);
			if ($ex) { $res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> "; last;}
		}

		# 最後の行番号ならツリー全体の降順表示リンクを追加
		undef $revdisp;
		undef $revtree;
		if ($i == ($nofline - 1)) {
			$revtree = "<a href=\"$readshtml&tree=1&no=$num&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\"></a>";
			$revdisp = "<a href=\"$readshtml&tree=1&no=$num&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\"></a>";
		}

		# 携帯電話からのアクセスのときはサブツリーのリンクを表示しない (2008/12/08 スガラボット修正)
		if (!$ua) {
			print &strEncode("<SPAN STYLE=\"font-family:'monospace';\"><font size=\"+1\" color=\"#338B33\">$pre1</font></SPAN>");
			print "<a href=\"$readshtml&tree=1&no=$num&l=$no[$i]-\"><font color=\"green\">";
			print &strEncode("▼</font></a>");
			print "<a href=\"$readshtml&tree=1&no=$num&l=-$no[$i]\">";
			print &strEncode("<font color=\"green\">△</font></a> ${st1}No.$no[$i] &nbsp;［$res_icon");
			print "<a href=\"$readshtml&tree=1&no=$num&l=$no[$i]\">";
			print &strEncode("$sub[$i]</a>］$revtree$revdisp&nbsp;<b>$nam[$i]</b> &nbsp;$dat[$i]$st2 \n");
		} else {
			if (!$resto[$i]) { $head_mark = "●"; }
			else { $head_mark = "■"; }
			print &strEncode("<font size=\"+1\" color=\"#338B33\">$pre1</font><font color=\"green\" size=\"-2\">$head_mark </font>" .
				" ${st1}No.$no[$i] &nbsp;［$res_icon");
			print "<a href=\"$readshtml&tree=1&no=$num&l=$no[$i]\">";
			print &strEncode("$sub[$i]</a>］$revdisp&nbsp;<b>$nam[$i]</b> &nbsp;$dat[$i]$st2 \n");
		}
		if (time < $tim[$i] + $hot) { print "<font color=\"#FF3300\"> <b>new!</b></font>"; }
		print "<br>\n";
		
		if ($chid[$i] != 0) {
			# 自分に子供が有るとき
			if ($next[$i] == $chid[$prnt[$i]]) {
				# 最後のノード
			} else {
				# 最後以外のノード
			}
			&lst_find($chid[$i], $pre2);		# 1レベル字下がりして再帰的に子ノードを印刷する
		}
	
		$i = $next[$i];						# 子供がないときは次ノードを印刷する
    } until ($i == $idx);
}

#-------------------------------------------------
#  検索語をハイライト表示
#-------------------------------------------------
sub highlight {
	my ($s, $ref, $change) = @_;
	my @keywd = ();
	@keywd = @{ $ref };

	# 検索語を一つずつハイライト処理
	my $word = '';
	foreach ( @keywd ) {

		$word = $_;

		# 検索語内の特殊文字をエスケープ
		eval { $word =~ s/([\+\-\*\.\?\^\$\[\]\|\(\)\\])/\\$1/g; };
		if ($@) { print "keyword replacement error! : $@<br>"; }

		# タグの外側で検索語がマッチすればハイライト
		eval { if ($change) { $s =~ s/((?:\G|>)[^<]*?)($word)/$1$strong1c$2$strong2c/ig; }
				else { $s =~ s/((?:\G|>)[^<]*?)($word)/$1$strong1a$2$strong2a/ig; } };
		if ($@) { print "string replacement error! : $@<br>"; }
	}

	return $s;
}

#-------------------------------------------------
#  検索語サーチのサブルーチン
#-------------------------------------------------

# 検索語で文字列をサーチ
sub search {
	my ($s, $wd) = @_;

	# 検索語内の特殊文字をエスケープ
	$wd =~ s/([\+\-\*\.\?\^\$\[\]\|\(\)\\])/\\$1/g;

	# 文字列内の<br>とBBCodeを削除する
	$s =~ s/<br>//g;
##	$s =~ s/(\[.+?\])//g;
#	$s =~ s/(\[(b|i|u|d|color|size|hr|url|list|\*|quote|code).*?\])//g;
#	$s =~ s/(\[\/(b|i|u|d|color|size|hr|url|list|quote|code)\])//g;
	&bbcoderm($s);

	my $i = 0;
#	# 検索語が<>タグの外側でマッチするか調べる
#	if ($s =~ /(?:\G|>)[^<]*?$wd/) { $i++; }
	if ($s =~ /$wd/) { $i++; }

	return $i;
}

#-------------------------------------------------
#  BBCodeの削除
#-------------------------------------------------
sub bbcoderm {
	# BBCode を削除
	my $s = $_[0];
	if (!$bbhide) { return $s; }
	if ($s !~ /\[(.*?)\]/) { return $s; }
#	$s =~ s/([\x81-\x9F\xE0-\xFC].)/$1\0/g;
	$s =~ s/\[b\](.*?)\[\/b\]/$1/ig;
	$s =~ s/\[i\](.*?)\[\/i\]/$1/ig;
	$s =~ s/\[u\](.*?)\[\/u\]/$1/ig;
	$s =~ s/\[d\](.*?)\[\/d\]/$1/ig;
	$s =~ s/\[color=([A-Z]+|#[0-9A-F]{6})\](.*?)\[\/color\]/$2/ig;
	$s =~ s/\[size=([\+\-]?[1-7])\](.*?)\[\/size\]/$2/ig;
	$s =~ s/\[hr(.*?)\]//ig;
	$s =~ s/\[url=((https?|ftp):\/\/[\w\!\#\$\%\&\'\(\)\*\+\,\-\.\/\:\;\=\?\@\~]*)\](.*?)\[\/url\]/$3/ig;
	$s =~ s/\[url=([1-3])\](.*?)\[\/url\]/$2/ig;
	$s =~ s/\[list\](.*?)\[\/list\]/$1/ig;
	$s =~ s/\[list=(1|A)\](.*?)\[\/list\]/$2/ig;
	$s =~ s/\[\*\]//ig;
	$s =~ s/\[quote\](.*?)\[\/quote\]/$1/ig;
	$s =~ s/\[code\](.*?)\[\/code\]/$1/ig;
	$s =~ tr/\0//d;
	return $s;
}

1;