# 過去ログ書庫インデックスファイル作成用に admin.cgi から分離独立させたサブルーチン
# 2010/11/26 スガラボット作成

use utf8;
$ver .= ", past_log version: 1.41";
# 2010/12/19 つり逆順表示とスレッド全体降順表示アイコンの表示場所変更

# list display
#----------------------------------------------------
# ツリー構造のポインターリストを印刷するサブルーチン
#----------------------------------------------------

#	$pre = '';
#	$pre1a = '├';
#	$pre1b = '└';
#	$pre2a = '│';
#	$pre2b = '　';

sub lst_dsp3 {
    my ($idx, $pre) = @_;			# 引数はデータの行番号とプレフィックス文字列
    my ($i, $link);

#printf("lst_dsp2(%d)\n", $idx);

# デバッグプリント
#&error("check point No.4");

	$i = $idx;
	do {
		# プリント順序カウンタをインクリメント
		$pr_count++;

		if ($next[$i] == $chid[$prnt[$i]]) {
			# 自分の次ノードが長男のポインタと同じなら最後のノード
			$pre1 = $pre.$pre1b;
			$pre2 = $pre.$pre2b;
		} else {
			# 最後以外のノード
			$pre1 = $pre.$pre1a;
			$pre2 = $pre.$pre2a;
		}
#		printf("%-20s %-11s %-10s\n",
#			$pre1.$data[$i], $date[$i], $user[$i]);

# もし特定のレスを指定したツリー表示ならそのレスを強調表示する
		if ($from > 0 && $from == $no[$i]) { $st1 = $strong1; $st2 = $strong2; }
		else { $st1 = ''; $st2 = ''; }

		# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
		if ($patio_trip) {
			$nam[$i] =~ s/[◆◇].+//g;
		}
		
# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
		$sub[$i] = &$titlebb($sub[$i]);
		$nam[$i] = &$titlebb($nam[$i]);

		# 添付ファイルのアイコン定義
		$res_icon = '';
		foreach $k (1 .. 3) 
		{
			local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][$i]);
			if ($ex) { 
				$res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> ";
				push(@upl_files, "$tim[$i]-$k$ex");
			} else {
				last;
			}
		}

		# 最後の行番号ならツリー全体の降順表示リンクを追加
		undef $revdisp;
		undef $revtree;
		my $readshtml_p = $readshtml . "&pastdir=$pastdir/$past_page_dir[$n]";
#		if ($i == ($nofline - 1)) {
#			$revtree = "<a href=\"$readshtml&tree=1&no=$num&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\"></a>";
#			$revdisp = "<a href=\"$readshtml&tree=1&no=$num&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\"></a>";
#		}
		# 下向けツリー表示か逆順表示アイコンかを定義
		my $link_icon;
		if ($pr_count == ($nofline - 1)) {
			$link_icon .= "<a href=\"$readshtml&tree=1&no=$no&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\" align=\"middle\"></a>";
			$revtree = "<a href=\"$readshtml&tree=1&no=$num&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\"></a>";
		} 
		if ($i == ($nofline - 1)) {
			$link_icon .= "<a href=\"$readshtml&tree=1&no=$no&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\" align=\"middle\"></a>";
			$revdisp = "<a href=\"$readshtml&tree=1&no=$num&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\"></a>";
		} 
		if ($i != ($nofline - 1) && $pr_count != ($nofline - 1)) {
			$link_icon = "<a href=\"$readshtml&tree=1&no=$no&l=$no[$i]-\"><font color=\"green\">▼</font></a>";
		}

		# 携帯電話からのアクセスのときはサブツリーのリンクを表示しない (2008/12/08 スガラボット修正)
		if (!$ua) {
			$print_string .= "<SPAN STYLE=\"font-family:'monospace';\"><font size=\"+1\" color=\"#338B33\">$pre1</font></SPAN>$st1" . 
			"$link_icon" .
				"<a href=\"$readshtml&tree=1&no=$num&l=-$no[$i]\"><font color=\"green\">△</font></a>" .
				" No.$no[$i] &nbsp;［$res_icon<a href=\"$readshtml&tree=1&no=$num&l=$no[$i]\">$sub[$i]</a>］&nbsp;<b>$nam[$i]</b> &nbsp;$dat[$i] $st2<br>\n";
		} else {
			if (!$resto[$i]) { $head_mark = "●"; }
			else { $head_mark = "■"; }
			if ($revdisp) { $head_mark = $revdisp; }
			$print_string .= "<font size=\"+1\" color=\"#338B33\">$pre1</font><font color=\"green\" size=\"-2\"> $head_mark </font>$st1" .
				" No.$no[$i] &nbsp;［$res_icon<a href=\"$readshtml&tree=1&no=$num&l=$no[$i]\">$sub[$i]</a>］&nbsp;<b>$nam[$i]</b> &nbsp;$dat[$i] $st2<br>\n";
		}
		
		if ($chid[$i] != 0) {
			# 自分に子供が有るとき
			if ($next[$i] == $chid[$prnt[$i]]) {
				# 最後のノード
			} else {
				# 最後以外のノード
			}
			&lst_dsp3($chid[$i], $pre2);		# 1レベル字下がりして再帰的に子ノードを印刷する
		}
	
		$i = $next[$i];						# 子供がないときは次ノードを印刷する
    } until ($i == $idx);
}

# create_pindex
#--------------------------------------------------------------------
# ツリー構造の過去ログ書庫ページ・インデックスを作成するサブルーチン
#--------------------------------------------------------------------
sub create_pindex {

	my ($buf) = @_;

	local ($num,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime) = split(/<>/, $buf);

	# アラーム数定義
	my $alarm = int ( $m_max * 0.9 );

	# スレッド毎のツリー表示インデックス作成する
	# スレッドタイトルを抽出
	my $tsub = $sub;

	# スレッド読み込み
	my ($IN, @log);
	open($IN, "+< $logdir/$num.cgi") || &error("Open Error: $num.cgi");
	@log = &arrayDecode($IN, $logchar);
#	close($IN);

	my $top1 = $log[0];
	my ($no,$lsub,$lres,$key) = split(/<>/, $top1);

	# $key を過去ログの属性 "-1" に変更する
	$log[0] = "$no<>$lsub<>$lres<>-1<>$key<>\n";

	seek($IN, 0, 0);
	my @temp = @log;
	print $IN &arrayEncode(\@temp, $logchar);
	truncate($IN, tell($IN));
	close($IN);

	# ツリー構造のリンクリストを作成するためトピックスのログファイルを一度全部読み込む。
	local (@prnt, @chid, @next, @prev, $j);
	$prnt[0] = 0;
	$chid[0] = 0;
	$no[0] = 0;
	$j = 1;

	local (@no,@sub,@nam,@eml,@com,@dat,@ho,@pw,@url,@mvw,@myid,@tim,@upl,@idcrypt,@color,@resto);
	my $line;
	for ($line = 0; $log[$j]; $line++) {
		chomp($log[$j]);
		($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
				$myid[$line],$tim[$line],$upl[1][$line],$upl[2][$line],$upl[3][$line],$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $log[$j]);
		$prnt[$line] = $resto[$line];

		$j++;
	}
	local $nofline = $line;

# ツリー構造のインデックス・リストを作成
#	prnt: 親ノード (parent node)
#	chid: 子ノード (child node)
#	next: 次ノード (兄弟リンクのnext node)
#	prev: 前ノード (兄弟リンクのprevious node)

	# スレッドのツリー表示がずれるのを修正するため、ツリーリストを作成するときはその都度@lineno関数をクリアする (20081015 スガラボット修正)
	undef @lineno;

# デバッグプリント
#&error("check point No.4");

	for ($line = 0; $line < $nofline; $line++) {
		&lst_cre($line, $prnt[$line], $no[$line]);
	}

# デバッグプリント
#&error("check point No.4");

	if (!$init) {
		$print_string .=   "<tr><td>&nbsp;</td></tr>";
	}
	$init = 0;
	$print_string .=   "<tr><td align=\"left\" nowrap>\n";

	# アイコン定義
	if ($key eq '0' || $key eq '4') { $icon = 'fold3.gif'; }
	elsif ($key eq '3') { $icon = 'fold4.gif'; }
	elsif ($key eq '2') { $icon = 'look.gif'; }
	elsif ($res >= $alarm) { $icon = 'fold5.gif'; }
	elsif ($upl) { $icon = 'fold6.gif'; }
	else { $icon = 'fold1.gif'; }

	# 添付ファイルのアイコン定義
	$res_icon = '';
	my @upl_files;
	foreach $k (1 .. 3) 
	{
		local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][0]);
		if ($ex) { 
			$res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> ";
			push(@upl_files, "$tim[0]-$k$ex");
		} else {
			last;
		}
	}

# スレッ覧からトリップを消したい場合有効にする
#	$nam[0] =~ s/◆.+//g;
#	$na2[0] =~ s/◆.+//g;

	# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
	if ($patio_trip) {
		$nam[0] =~ s/[◆◇].+//g;
	}
	
	# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
	$sub[0] = &$titlebb($sub[0]);	
	$nam[0] = &$titlebb($nam[0]);	
	$tsub = &$titlebb($tsub);

	#スレッドタイトルとレス親題名を分離したことに因る処理
	local ($sub1, $sub2);
	if ($sub[0] ne $tsub) {
		$sub_dif = 1;
		$sub1 = "&nbsp;&nbsp;<b>スレッド $num: $tsub &nbsp;</b><br><img src=\"$imgurl/spacer_h4.gif\"><br>";
		$sub2 = " No.0 &nbsp;";
	} else {
		$sub2 = "<b>スレッド $num:</b>";
	}

	# スレッドのプリント順序をカウンタを初期化
	our $pr_count = 0;
	
	# スレッドの親記事を表示
	$print_string .=  $sub1;

	my $readshtml_p = $readshtml . "&pastdir=$pastdir/$past_page_dir[$n]";
	# 携帯からのアクセスのときは全表示でツリー表示をしない （2008/12/08 スガラボット修正)
	if (!$ua) {
		$print_string .=  "&nbsp;&nbsp;&nbsp;<a href=\"$readshtml&tree=1&no=$num&l=all\"><img src=\"$imgurl/tree.gif\" border=\"0\" align=\"middle\"></a>\n";
		$print_string .=  " <a href=\"$readshtml&no=$num\"><img src=\"$imgurl/$icon\" border=\"0\"></a> $st1 $sub2 ［$res_icon<a href=\"$readshtml&tree=1&no=$num&l=0\">$sub[0]</a>］&nbsp;<b>$nam[0]</b> &nbsp;$dat[0] $st2 \n";
	} else {
		$print_string .=  "&nbsp;&nbsp;&nbsp;<a href=\"$readshtml&no=$num\"><img src=\"$imgurl/$icon\" border=\"0\"></a>\n";
		$print_string .=  " $sub2 ［$res_icon<a href=\"$readshtml&tree=1&no=$num&l=0\">$sub[0]</a>］&nbsp;<b>$nam[0]</b> &nbsp;$dat[0] $st2 \n";
	}

	$print_string .= "&nbsp;$dat[0]<br>\n";


#	$pre = '　';
#	$pre1a = '├';
#	$pre1b = '└';
#	$pre2a = '│';
#	$pre2b = '　';
	
	$pre = "<img src=\"$imgurl/blank.gif\">";
	$pre1a = "<img src=\"$imgurl/branch.gif\">";
	$pre1b = "<img src=\"$imgurl/next.gif\">";
	$pre2a = "<img src=\"$imgurl/down.gif\">";
	$pre2b = "<img src=\"$imgurl/blank.gif\">";

# デバッグプリント
#&error("check point No.4");

	# スレッドを階層表示
	if ($chid[0]) {
		&lst_dsp3($chid[0], $pre);
	}
	$print_string .=   "</td></tr>\n";
#	$print_string .=   "</table><br>\n";

# デバッグプリント
#&error("check point No.4");

#	push(@num_list, $num);
	return $num;
}


1;
