#┌────────────────────────
#｜RSS/Atom for Web Patio ver.0.12 Copyright (c) 如水／円
#│http://jyosui.xrea.jp/
#└────────────────────────
# 注意事項
#  1. このスクリプトはフリーソフトです。このスクリプトを使用した
#     いかなる損害に対しても作成者は一切の責任を負いません。
#  2. 著作権や配布URLの表示を削除、変更しない限り改造、再配布は自由です。

############################################
# Forum Patio 用スガラボット版
# スガラボット版は以下の設定はinit.cgiで設定
# 複数会議室版 v1.50 では1184行目あたり以降
#
# 修正履歴
# v1.50: 2012/07/07 v1.4x 版で機能的に未完成だった部分を全面的に改定した。
# ・Forum Patio の｢スレッド一覧｣トップページに、投稿、管理者の修正削除などのサマリーを追加
# ・管理者による記事の修正削除、スレッドの削除や過去ログへの移動、スレッド改番や分割連結に対応
# ・フィード再構築では、フィードログも作り直すこととした。
# ・W3C の Feed Validator による検証に合格することを確認
#
############################################

# ログファイル【サーバパス】
#$feedlog = './data/feed.log';

# 掲示板本体CGI【URL】
#$bbsurl = 'http://your.domain.com/patio/patio.cgi';

# 掲示板閲覧CGI【URL】
#$readurl = 'http://your.domain.com/patio/read.cgi';

# タイトル
#$feed_title = 'Fresh Posts of WebPatio';

# 簡単な説明
#$feed_des = '新規投稿のお知らせ';

# コメントの頭から全角～文字分までを<description>,<summary>に出力する。
# 0にすると全文を出力する。
#$len = 200;

# 画像がアップロードされている場合<description>,<summary>の最初にこの文字列が付与される
#$mark = "【画像有り】";

# 出力する最大件数
#$feed_num = 5;

### RSS1.0 ###
# 出力する文字コード
# 0 = sjis
# 1 = euc / jcode(g).pl 使用
# 2 = euc / Jcode.pm 使用
# 3 = utf8 / Jcode.pm 使用
#$rss1_code = 3;

# RSSファイル位置の【絶対パス】
#$rss1url = 'http://your.domain.com/patio/feed.rdf';

### RSS2.0 ###
# 出力する文字コード（数字の意味は$rss1_codeと同じ）
#$rss2_code = 3;

### Atom1.0 ###
# 出力する文字コード（数字の意味は$rss1_codeと同じ）
#$atom_code = 3;

# RSSファイル位置の【絶対パス】
#$atomurl = 'http://your.domain.com/patio/feed.atom';

# DNS名
#$dns = 'www.yourdomin.com';

# ローカル名 （大抵はディレクトリ名？）
# この後にスレッド番号（$num）またはスレッド/レス番号（$num/$rno）が付与されます
$lname = $room ? "/$room/" : '/bbs/';

# デバッグ用に feedlog のバックアップファイルを日時を付けて保存するかどうか ( =1 にすると日時付けで保存)
my $debug = 0;

#---------------------------------------------
# 設定終了
#---------------------------------------------

#use strict;
#use warnings;
#use Time::Local;
use utf8;

# ツリー形式のインデックスから閲覧していたときはスレッドをツリー表示する
if ( $forumflg eq 'bbs=forum' ) { $readurl .= $treeflg; }

sub feed {
	# $past フラグ(-1:過去ログ化、1:過去ログから復帰)を追加 （2009/10/28 スガラボット追加修正)
	our ($job, $past) = @_;
	our (@feed,$feedtop,$rfc822,$w3cdtf,$fflag,$pubdate,$w3cdate,$w3cudate);
	our ($fcom, $bakdate, $del_notice, $nam_del, $pdate_del, $w3cdtf_del);				# (2009/11/02 スガラボット修正)
	my ($FEED, @newfeed);

	$readurl =~ s/&/&amp;/g;

	# SSIによる複数会議室対応かどうか (2009/11/04 スガラボット追加修正)
	if (!$patioshtml) { $patioshtml = $patiocgi; }
	if (!$forumshtml) { $forumshtml = $forumcgi; }
	if (!$readshtml) { $readshtml = $readcgi; }

	$fcom = $i_com;

	# スレッドテーマのBBCodeを削除
	$tsub = &titlebbrm($tsub);

	if (-e $feedlog) {

		open($FEED,"+< $feedlog") || &error("Open Error: $feedlog");

		eval "flock($FEED, 2);";
		$feedtop = &lineDecode($FEED);		# (2009/10/15 スガラボット修正)
		($pubdate,undef,$w3cdate, $w3cudate) = split(/<>/, $feedtop);

		# 新規投稿
		if($job eq "reg"){
			@feed = &arrayDecode($FEED);
			&pre();
			&date_time();
			$pubdate = $rfc822;
			$w3cdate = $w3cdtf;

			if ($in{'res'} eq "") {
				# スレッドテーマの分離	（2009/10/19 スガラボット追加修正)
				if ($tsub eq $in{'sub'}) { $tsub = ''; }

				unshift(@feed,"$new<>0<>$tsub<>$i_sub<>$w3cdtf<>$rfc822<>$w3cdtf<>$i_nam2<>$fcom<>$reg_upl<><>\n");
			} else {

				# スレッドテーマのが空のときは<0>マークを付けてスレッド親発言を記録	（2009/10/22 スガラボット追加修正)
				if (!$tsub) { $tsub = "<0>$ressub0"; }

				unshift(@feed,"$reg_no<>$newno<>$tsub<>$i_sub<>$w3cdtf<>$rfc822<>$w3cdtf<>$i_nam2<>$fcom<>$reg_upl<>$resto<>\n");
			}

			$feedtop = "$pubdate<>$rfc822<>$w3cdate<>$w3cdtf<>\n";

			close ($FEED);

		# 修正
		} elsif($job eq "edit") {
			local ($eflag,$temp);

			# スレッド親記事の修正ならスレッドテーマの分離	（2009/10/19 スガラボット追加修正)
			my $top_edit = 0;
			my $tsub0;
			if (!$in{'no'}) {
				$top_edit = 1;
				if ($in{'tsub'} eq $in{'sub'}) {
					$tsub = '';
					$tsub0 = '<0>' . $in{'sub'};
				} else {
					$tsub = $in{'tsub'};
					$tsub0 = $tsub;
				}
			}

			# FEEDログファイルを全部配列に読み込む
			my @feedlog = &arrayDecode($FEED);

			foreach ( @feedlog ) {			# 2009/11/10 スガラボット修正)
				my($num,$rno,$rtsub,$ri_sub,$rpdate,$pdate2,$rw3cdtf,$ri_nam,$rfcom,$redit_upl,$rresto) = split(/<>/);
				
				# 修正された記事の更新内容
				if(($in{'f'} eq $num) && ($in{'no'} eq $rno)) {
					&pre();


#					# もしスレッド親記事の修正でなければ元のスレッドテーマを用いる
					if (!$top_edit) { $tsub = $rtsub; }

					&date_time();

					if ( $in{'myjob'} eq 'admin' ) {
						my $temp = "$num<>$rno<>$tsub<>$i_sub<>$rpdate<>$pdate2<>$rw3cdtf<>$i_nam<>$fcom<>$edit_upl<>$in{'resto'}<>\n";
						push (@newfeed,$temp);
					} else {
						my $temp = "$num<>$rno<>$tsub<>$i_sub<>$rpdate<>$rfc822<>$w3cdtf<>$i_nam<>$fcom<>$edit_upl<>$in{'resto'}<>\n";
						unshift (@newfeed,$temp);
					}

					$feedtop = "$pubdate<>$rfc822<>$w3cdate<>$w3cdtf<>\n";

					$eflag = 1;
					next;
				}
				# スレッド親記事が修正されたときはそのスレッド全記事のスレッドテーマを更新する
				elsif ($top_edit && ($in{'f'} == $num)) {
					push (@newfeed, "$num<>$rno<>$tsub0<>$ri_sub<>$rpdate<>$pdate2<>$rw3cdtf<>$ri_nam<>$rfcom<>$redit_upl<>$rresto<>\n");
					next;
				}
				# 修正対象外の記事はそのまま詰め込む
				else { push (@newfeed,"$_"); }
			}
			# 古い記事の修正でFEEDログファイルの中に前回登録時の記事が無かったとき
			if (!$eflag) {
				&pre();
				my $temp;
				if (!$in{'no'}) { $temp = "$num<>0<>$tsub<>$i_sub<>$w3cdtf<>$rfc822<>$w3cdtf<>$i_nam<>$fcom<>$edit_upl<>$in{'resto'}<>\n"; }
				else {
					if (!$tsub) { $tsub = "<0>$ressub0"; }
					$temp = "$num<>$in{'no'}<>$tsub<>$i_sub<>$w3cdtf<>$rfc822<>$w3cdtf<>$i_nam<>$fcom<>$edit_upl<>$in{'resto'}<>\n";
				}
				unshift(@newfeed,$temp);

				&date_time();
				$feedtop = "$rfc822<>$rfc822<>$w3cdtf<>$w3cdtf<>\n";
			}

			close ($FEED);

		# レス削除：ユーザが記事の｢修正･削除｣をクリックして記事を削除したときは、記事が削除されたことを
		# FEED トップページのスレッド一覧に一度だけ削除表示する。(次にFEED更新があったときは削除経歴は表示しない)
		} elsif($job eq "del") {			# 2009/10/22 以下スレッド削除までの処理をスガラボット修正)

			# 削除情報を配列化
			local @del = split(/\0/, $in{'no2'});

			# FEEDログファイルを全部配列に読み込む
			my @feedlog = &arrayDecode($FEED);

			foreach ( @feedlog ) {			# 2009/11/10 スガラボット修正)
#				my($num,$rno) = split(/<>/);
				my($num,$rno,$rtsub,$ri_sub,$rpdate,$pdate2,$rw3cdtf,$ri_nam,$rfcom,$redit_upl,$rresto) = split(/<>/);

				my $dflag = 0;
				if (($in{'f'} eq $num) && ($in{'no'} eq $rno)) {
					&date_time();

					($pubdate,undef,$w3cdate) = split(/<>/, $feedtop);

					# 削除の記事は削除日付を入れて先頭に"-"を付けるだけ
					my $temp = '-' . "$num<>$rno<>$rtsub<>r$i_sub<>$rpdate<>$rfc822<>$w3cdtf<>$ri_nam<>$rfcom<>r$edit_upl<>$rresto<>\n";
					unshift(@newfeed, $temp);  

					$feedtop = "$pubdate<>$rfc822<>$w3cdate<>$w3cdtf<>\n";

					$fflag = 1;
					$dflag = 1;
				}

				# 管理者による個別記事削除の場合
				foreach my $del (@del) {
					if (($in{'no'} eq $num) && ($del eq $rno)) {
						&date_time();

						($pubdate,undef,$w3cdate) = split(/<>/, $feedtop);

						# 管理者による記事削除の記事は記事をトップにソートせず、先頭に"-"を付けるだけ
						my $temp = '-' . "$num<>$rno<>$rtsub<>$ri_sub<>$rpdate<>$pdate2<>$rw3cdtf<>$ri_nam<>$rfcom<>$redit_upl<>$rresto<>\n";
						push(@newfeed, $temp);  

						$feedtop = "$pubdate<>$rfc822<>$w3cdate<>$w3cdtf<>\n";

						$fflag = 1;
						$dflag = 1;
						last;
					}
				}

				if(!$dflag) { push(@newfeed,"$_"); }
			}

			close ($FEED);

		# スレッド削除と過去ログ化・過去ログから復帰 (管理者がスレッドや記事を削除したときはトップページのスレッド一覧に削除表示をしない)
		} elsif($job eq "admin") {

			# FEEDログファイルを全部配列に読み込む
			my @feedlog = &arrayDecode($FEED);

			foreach ( @feedlog ) {			# 2009/11/10 スガラボット修正)
				my $dflag = 0;
				my($num) = split(/<>/);
				
				# 削除
				if (!$past) {
					foreach my $del (@del) {
						if ($del eq $num) {
							$dflag=1; $fflag =1; last;
						}
					}
				}
				# 過去ログ化
				elsif ($past eq '-1') {
					foreach my $del (@del) {
						if ($del eq $num) {
							# 過去ログに移動する記事は先頭に"-"を付けるだけ (既に"-"が付いているときはそのまま)
							if (substr($num, 0, 1) ne '-') { $_ = '-' . $_; }
							push (@newfeed, $_);
							$dflag=1;
							# 削除待避ログから過去ログへ復帰のときはフィードを更新しない
							if ( !$in{'delfile'} ) { $fflag =1; }
							last;
						}
					}
				}
				# 過去ログから復帰
				elsif ($past eq '1') {
					foreach my $lock (@lock) {
						$num =~ s/^-(\d+)/$1/;
						if ($lock eq $num) {
							# 過去ログからの復帰時は最初のマイナスを削除
							$_ =~  s/^-(.+)/$1/;
							push (@newfeed, $_);
							$dflag=1; $fflag =1; last;
						}
					}
				}
				if(!$dflag) { push (@newfeed,"$_"); }
			}
			if($fflag) {
				&date_time();
				$feedtop = "$pubdate<>$rfc822<>$w3cdate<>$w3cdtf<>\n";
			}
			# もし過去ログからの復帰など処理すべき記事が一つも見つからなかったらフィードログを再構築する
			else {
				close ($FEED);
				# 処理中に作成したデータは破棄する
				@newfeed = ();

				# フィードバックアップを作成
				if ( $debug ) { rename("$feedlog", "$feedlog.bak${bakdate}"); }
				else { rename("$feedlog", "$feedlog.bak"); }

				# フィードログを再構築
				&log_create;
				$feedtop = shift(@feed);		# (2009/11/26 スガラボット修正)
				$feedtop = "$pubdate<>$rfc822<>$w3cdate<>$w3cdtf<>\n";
				$fflag = 1;
			}

			close ($FEED);

		# スレッド分割・連結及びスレッド改番
		} elsif($job eq "renumber") {

			# スレッド連結なら新しいスレッドのスレッドテーマを抽出
			my (@newt0, $topt0);
			open(OUT, "+<$logdir/$to_thread.cgi") || &error("分割後のスレッドログが見当たりません! log=$logdir/$to_thread.cgi");
			eval "flock(OUT, 2);";
			@newt0 =  &arrayDecode(OUT) ;
			$topt0 = shift(@newt0);
			close OUT;

			my ($ntsub, $ntsub0, $ntsbu1, $ntsub2);
			(undef, $ntsub0) = split (/<>/, $topt0);
			my $topt1 = shift(@newt0);
			(undef, $ntsub1) = split (/<>/, $topt1);
			$ntsub2 = $ntsub0;
			if ($ntsub0 eq $ntsub1) { $ntsub2 = "<0>$ntsub0"; }

			# まず親記事に印を付ける
			$copy[$from] = 1;

			# FEEDログファイルを全部配列に読み込む
			my @feedlog = &arrayDecode($FEED);

			foreach ( @feedlog ) {			# 2009/11/10 スガラボット修正)
				my $temp = $_;
				local ($rnum,$rno,$rtsub,$ri_sub,$rpdate,$rpdate2,$rw3cdtf,$ri_nam,$rfcom,$r_upl,$rresto) = split(/<>/, $temp);
				
				# 親記事以降の前記事を一つずつチェックする
				my $mflag = 0;
				for ($from .. $num) {
					$j = $_;

					# 移動対象の記事ならスレッド番号と記事番号を新しい値に修正する
					if ($copy[$j] && $in{'no'} == $rnum && $no[$j] == $rno) {

						# スレッドテーマを更新する (もし分割後のスレッドテーマを付与する
						if (!$newline[$j] && $ntsub0 eq $ri_sub) { $ntsub = ''; }
						else { $ntsub = $ntsub2; }

						push (@newfeed,"$to_thread<>$newline[$j]<>$ntsub<>$ri_sub<>$rpdate<>$rpdate2<>$rw3cdtf<>$ri_nam<>$rfcom<>$r_upl<>$new_prnt[$j]<>\n");

						$mflag = 1;
						$fflag = 1;
						last;
					}
				}
				if (!$mflag) { push (@newfeed, $temp); }
			}
			
			if($fflag) {
				&date_time();
				$feedtop = "$pubdate<>$rfc822<>$w3cdate<>$w3cdtf<>\n";
			}

			close ($FEED);

		# ｢管理用｣から FEED 再構築を指定されたとき
		} elsif ($job eq 'create') {
#			@feed = &arrayDecode($FEED);
			# FEEDログ作り直しのときは、現在のFEEDログファイルをバックファイルにリネーして新しく作り直す。。
			close ($FEED);

			# フィードバックアップを作成
			if ( $debug ) { rename("$feedlog", "$feedlog.bak${bakdate}"); }
			else { rename("$feedlog", "$feedlog.bak"); }

			&log_create;
			$feedtop = shift(@feed);		# (2009/11/26 スガラボット修正)
			$feedtop = "$pubdate<>$rfc822<>$w3cdate<>$w3cdtf<>\n";
			$fflag = 1;
		}

	} else {	# フィードログがなければ作成する (2009/10/30 スガラボット追加修正)
		&log_create;
		$feedtop = shift(@feed);		# (2009/11/26 スガラボット修正)
		(undef, $rfc822, undef, $w3cudate) = split(/<>/, $feedtop);
		$fflag = 1;
	}

	if(!$fflag) { return; }

	if (@newfeed) { @feed = @newfeed; }

	unshift(@feed, $feedtop);

	local($temp) = $#feed;

	# フィードバックアップを作成
	if ( $debug ) { rename("$feedlog", "$feedlog.bak${bakdate}"); }
	else { rename("$feedlog", "$feedlog.bak"); }

	open($FEED,"> $feedlog") || &error("Open Error: $feedlog");
	my @feed_copy = @feed;
	print $FEED &arrayEncode(\@feed_copy, $logchar);
	truncate($FEED, tell($FEED));
	close($FEED);

	shift(@feed);

	if($rss1patiofile) { &rss1('patio'); }
	if($rss2patiofile) { &rss2('patio'); }
	if($atompatiofile) { &atom('patio'); }
	if($rss1forumfile) { &rss1('forum'); }
	if($rss2forumfile) { &rss2('forum'); }
	if($atomforumfile) { &atom('forum'); }

}

#############################
# サブルーチン thread_feed 
# (read.cgi/read.shtml のスレッド閲覧ページからのRSSフィード取得ルーチン （2009/10/27 スガラボット追加)
#############################

sub thread_feed {
	my($rss, $thno, $max_feed) = @_;
	our (@feed,$feedtop,$pubdate,$pubdate2,$w3cdate,$w3cudate);
	my $FEED;

	# SSIによる複数会議室対応かどうか (2009/11/04 スガラボット追加修正)
	if (!$patioshtml) { $patioshtml = $patiocgi; }
	if (!$forumshtml) { $forumshtml = $forumcgi; }
	if (!$readshtml) { $readshtml = $readcgi; }

	$readurl =~ s/&/&amp;/g;

	if (-e $feedlog) { open($FEED,"+< $feedlog") || &error("Open Error: $feedlog"); }
	else {
		# フィードログがなければ作成する (2009/10/30 スガラボット追加修正)
		&log_create;
		open($FEED,"+< $feedlog") || &error("Open Error: $feedlog");
	}

	eval "flock($FEED, 2);";

	# フィードログ読み込み
	$feedtop = &lineDecode($FEED);
	($pubdate, $pubdate2, $w3cdate, $w3cudate) = split(/<>/, $feedtop);
	@feed = &arrayDecode($FEED);

	close($FEED);

	# FEED作成
	my $out = &$rss($in{'bbs'}, $thno, $max_feed);
	
	# ヘッダ送出
	print "Content-Type: text/xml; charset=$htmlcode\nPragma: no-cache\nCache-Control: no-cache\n\n";

	# FEED送出
	print &strEncode($out);
}

# RSS1.0
sub rss1 {

	# 引数に最大件数を追加 （2009/10/27 スガラボット追加修正)
	my ($bbs, $thno, $max_feed) = @_;

	# 閲覧するトップページが'patio'か'forum'かによってリンク先を変える
	my $rss1url;
	if ($bbs eq 'patio' || $fb eq 'patio') {
		$bbsurl = "$url_root$patioshtml";
		$bbsurl =~ s/&/&amp;/g;
		$rss1url = "$url_root$rss1patiourl";
	} elsif ($bbs eq 'forum' || $fb eq 'forum') {
		$bbsurl = "$url_root$forumshtml";
		$bbsurl =~ s/&/&amp;/g;
		$rss1url = "$urs_root$rss1forumurl";
	} elsif ($in{'view'} eq 'thread') {
		$patiocgi = $url_root . $patiocgi;
		$patiocgi =~ s/&/&amp;/g;
		$rdfurl = "$patiocgi?view=thread&amp;feed=rss1&amp;no=$in{'no'}"
	} 

	# もしスレッド閲覧ページからのアクセスならこのFEEDのURLはダイナミックなものに変更
	if ($max_feed) {
		$rss1url = "$url_root$readcgi&feed=rss1&no=$thno";
		$rss1url =~ s/&/&amp;/g;
		$feed_title = "${title} - [スレッドNo.${thno}] 新規投稿のお知らせ";
	} 

	my ($out, $out1, $out2);
	my ($feed_code) = $rss1_code;

	&xml;

	$out1 .= <<"EOM";
<rdf:RDF
   xmlns="http://purl.org/rss/1.0/"
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xml:lang="ja">
  <channel rdf:about="$rss1url">
    <title>$feed_title</title>
    <link>$bbsurl</link>
    <description>$feed_des</description>
    <items>
      <rdf:Seq>
        <rdf:li rdf:resource="$bbsurl"/>
EOM

	# patio.cgi のスレッド一覧から要求されたときはスレッド一覧ページを表示する (2009/11/26 スガラボット追加修正)
	if ($in{'view'} eq 'thread') {
		$patiocgi = $url_root . $patiocgi;
		$patiocgi =~ s/&/&amp;/g;

		$out1 .= <<"EOM";
        <rdf:li rdf:resource="$url_root$patiocgi&amp;view=thread&amp;no=$thno"/>
EOM
	}

	# スレッド閲覧ページの最大件数は $max_feed、トップページの最大件数は$feed_num とする (2009/10/27 スガラボット追加修正)
	our ($feed_cnt, $readurl2);
	if ($max_feed) { $feed_cnt = $max_feed; }
	else { $feed_cnt = $feed_num; }

	for($i = 0; $i <= $#feed; $i++) {
		my($num, $rno) = split(/<>/, $feed[$i]);
		# スレッド番号が負の数字なら過去ログのためスキップ	（2009/10/27 スガラボット追加修正)
		if (substr($num, 0, 1) eq '-') { next; }

		# スレッド閲覧ページからのRSSフィード作成なら指定スレッド番号以外の記事はスキップ	（2009/10/28 スガラボット追加修正)
		if ($thno && $thno ne $num) { next; }

		# 最大出力数制御 ($feed_cntが0になったら終了)
		if ($feed_cnt) { $feed_cnt--; }
		else { last; }

		$out1 .= "        <rdf:li rdf:resource=\"$readurl&amp;no=$num&amp;l=$rno\"/>\n";
	}

	$out1 .= <<"EOM";
      </rdf:Seq>
    </items>
  </channel>
EOM

	my ($bbsflg, $tflag);
	if ($max_feed) { $feed_cnt = $max_feed; }
	else {
		$feed_cnt = $feed_num;
		$bbsflg = "bbs=$bbs";
		if ($bbs eq 'forum') { $tflag = '&amp;tree=1'; }
	}

	our ($published, $naiyo1, $naiyo2, $t_first, $tagdate);
	our ($num,$rno,$tsub,$sub,$rfcdate,$pdate,$w3cdate,$nam,$com,$resto);
	for($i = 0; $i <= $#feed; $i++) {
		($num,$rno,$tsub,$sub,$rfcdate,$pdate,$w3cdate,$nam,$com,undef,$resto) = split(/<>/, $feed[$i]);

		my $sub0 = $sub;
		# 最新記事のスレッド番号、返信番号、投稿者、タイトル、日付を取得しておく
		if ($i == 0) {
			&edititem( 'top' );
			
			$out1 .= <<"EOM";
    <item rdf:about="$bbsurl">
      <title>${title}のスレッド一覧</title>
      <link>$bbsurl</link>
      <description>$naiyo1</description>
      <dc:creator>$nam</dc:creator>
      <dc:date>$w3cdate</dc:date>
    </item>
EOM
		}

		# スレッド番号が負の数字なら過去ログのためスキップ	（2009/10/27 スガラボット追加修正)
		if (substr($num, 0, 1) eq '-') { next; }

		# スレッド閲覧ページからのRSSフィード作成なら指定スレッド番号以外の記事はスキップ	（2009/10/28 スガラボット追加修正)
		if ($thno && $thno ne $num) { next; }

		# patio.cgi のスレッド一覧から要求されたときは返信番号、投稿者、タイトル、日付を取得しておく
		if (!$t_first) {
			$t_first = 1;
			$sub = $sub0;
			&edititem;
			
			$patiocgi =~ s/&/&amp;/g;
			$out1 .= <<"EOM";
    <item rdf:about="$url_root$patiocgi&amp;view=thread&amp;no=$thno">
      <title>${title}のスレッドNo.${in{'no'}} タイトル一覧</title>
      <link>$patiocgi&amp;view=thread&amp;no=$thno</link>
      <description>$naiyo2</description>
      <dc:creator>$nam</dc:creator>
      <dc:date>$w3cdate</dc:date>
    </item>
EOM
		}

		# 最大出力数制御 ($feed_cntが0になったら終了)
		if ($feed_cnt) { $feed_cnt--; }
		else { last; }

		if($rno) { $readurl2 = "$readurl&amp;$bbsflg&amp;no=$num&amp;l=-$rno&amp;rev=1"; }
		else { $readurl2 = "$readurl&amp;$bbsflg$tflag&amp;no=$num"; }

		$sub = $sub0;
		&edititem;

		$out2 .= <<"EOM";
    <item rdf:about="$readurl&amp;no=$num&amp;l=$rno">
      <title>$sub</title>
      <link>$readurl2</link>
      <description>$com</description>
      <dc:creator>$nam</dc:creator>
      <dc:date>$w3cdate</dc:date>
    </item>
EOM
	}

	$out2 .= "</rdf:RDF>\n";

	$out .= $out1 . $out2;

	# スレッド閲覧ページからの起動ならファイルを作成せずにリターン （2009/10/27 スガラボット追加修正)
	if ($max_feed) { return $out; }

	# 引数"$bss"によって作成するファイルを決める
	my $rss1file;
	if ($bbs eq 'patio') { $rss1file = $rss1patiofile; }
	elsif ($bbs eq 'forum') { $rss1file = $rss1forumfile; }

	open(OUT,"> $rss1file") || &error("Write Error: $rss1file");
	eval "flock(OUT, 2);";
	seek(OUT, 0, 0);
	print OUT &strEncode($out, $feed_code);
	truncate(OUT, tell(OUT));
	close(OUT);

}

# RSS2.0
sub rss2 {

	# 引数に最大件数を追加 （2009/10/27 スガラボット追加修正)
	my ($bbs, $thno, $max_feed) = @_;

	# 閲覧するトップページが'patio'か'forum'かによってリンク先を変える
	my $rss2url;
	if ($bbs eq 'patio' || $fb eq 'patio') {
		$bbsurl = "$url_root$patioshtml";
		$bbsurl =~ s/&/&amp;/g;
		$rss2url = "$url_root$rss2patiourl";
	} elsif ($bbs eq 'forum' || $fb eq 'forum') {
		$bbsurl = "$url_root$forumshtml";
		$bbsurl =~ s/&/&amp;/g;
		$rss2url = "$url_root$rss2forumurl";
	}

	# もしスレッド閲覧ページからのアクセスならこのFEEDのURLはダイナミックなものに変更
	if ($max_feed) {
		$rss2url = "$url_root$readcgi&feed=rss2&no=$thno";
		$rss2url =~ s/&/&amp;/g;
		$feed_title = "${title} - [スレッドNo.${thno}] 新規投稿のお知らせ";
	} 

	my ($out, $out1, $out2);
	my ($feed_code) = $rss2_code;

	&xml;

	$out1 .= <<"EOM";
<rss version="2.0"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:atom="http://www.w3.org/2005/Atom"
  xml:lang="ja">
  <channel>
    <title>$feed_title</title>
    <link>$rss2url</link>
    <atom:link href="$rss2url" rel="self" type="application/rss+xml" />
    <description>$feed_des</description>
    <language>ja</language>
EOM

	if($pubdate){
		$out1 .= "    <pubDate>$pubdate</pubDate>\n";
	} else {
		$out1 .= "    <pubDate>$rfc822</pubDate>\n";
	}

	$rfc822 = ($rfc822) ? $rfc822 : $pubdate2;
	$out1 .= "    <lastBuildDate>$rfc822</lastBuildDate>\n";

	# スレッド閲覧ページの最大件数は $max_feed、トップページとの最大件数は$feed_num とする (2009/10/27 スガラボット追加修正)
	our ($feed_cnt, $readurl2);
	if ($max_feed) { $feed_cnt = $max_feed; }
	else { $feed_cnt = $feed_num; }

	my ($bbsflg, $tflag);
	if ($max_feed) { $feed_cnt = $max_feed; }
	else {
		$feed_cnt = $feed_num;
		$bbsflg = "bbs=$bbs";
		if ($bbs eq 'forum') { $tflag = '&amp;tree=1'; }
	}

	our ($published, $naiyo1, $naiyo2, $t_first, $tagdate);
	our ($num,$rno,$tsub,$sub,$rfcdate,$pdate,$w3cdate,$nam,$com,$resto);
	for($i = 0; $i <= $#feed; $i++) {
		($num,$rno,$tsub,$sub,$rfcdate,$pdate,$w3cdate,$nam,$com,undef,$resto) = split(/<>/, $feed[$i]);

		my $sub0 = $sub;
		# 最新記事のスレッド番号、返信番号、投稿者、タイトル、日付を取得しておく
		if ($i == 0) {
			&edititem( 'top' );
			
	$out1 .= <<"EOM";
    <item>
      <title>${title}のスレッド一覧</title>
      <link>$bbsurl</link>
      <dc:creator>$nam</dc:creator>
      <description>$naiyo1</description>
      <pubDate>$pdate</pubDate>
      <guid isPermaLink="true">$bbsurl</guid>
    </item>
EOM
		}

		# スレッド番号が負の数字なら過去ログのためスキップ	（2009/10/27 スガラボット追加修正)
		if (substr($num, 0, 1) eq '-') { next; }

		# スレッド閲覧ページからのRSSフィード作成なら指定スレッド番号以外の記事はスキップ	（2009/10/28 スガラボット追加修正)
		if ($thno && $thno ne $num) { next; }

		# patio.cgi のスレッド一覧から要求されたときは返信番号、投稿者、タイトル、日付を取得しておく
		if (!$t_first) {
			$t_first = 1;
			$sub = $sub0;
			&edititem;
			
			$patiocgi = $url_root . $patiocgi;
			$patiocgi =~ s/&/&amp;/g;
			$out1 .= <<"EOM";
    <item>
      <title>${title}のスレッドNo.${in{'no'}} タイトル一覧</title>
      <link>$patiocgi&amp;view=thread&amp;no=$thno</link>
      <dc:creator>$nam_t0</dc:creator>
      <description>$naiyo2</description>
      <pubDate>$pdate_t0</pubDate>
      <guid isPermaLink="true">$patiocgi&amp;view=thread&amp;no=$thno</guid>
    </item>
EOM
		}

		# 最大出力数制御 ($feed_cntが0になったら終了)
		if ($feed_cnt) { $feed_cnt--; }
		else { last; }

		$sub = $sub0;
		&edititem;

		my $guidurl;
		if($rno) { 
			$readurl2 = "$readurl&amp;$bbsflg&amp;no=$num&amp;l=-$rno&amp;rev=1"; 
			$guidurl = "$readurl&amp;$bbsflg&amp;no=$num&amp;l=$rno";
		}
		else { 
			$readurl2 = "$readurl&amp;$bbsflg$tflag&amp;no=$num"; 
			$guidurl = "$readurl&amp;$bbsflg&amp;no=$num&amp;l=0";
		}

		$out2 .= <<"EOM";
    <item>
      <title>$sub</title>
      <link>$readurl2</link>
      <dc:creator>$nam</dc:creator>
      <description>$com</description>
      <pubDate>$pdate</pubDate>
      <guid isPermaLink="true">$guidurl</guid>
    </item>
EOM
	}

	$out .= $out1 . $out2;
	$out .= "  </channel>\n</rss>\n";

	# スレッド閲覧ページからの起動ならファイルを作成せずにリターン （2009/10/27 スガラボット追加修正)
	if ($max_feed) { return $out; }

	# 引数"$bss"によって作成するファイルを決める
	my $rss2file;
	if ($bbs eq 'patio') { $rss2file = $rss2patiofile; }
	elsif ($bbs eq 'forum') { $rss2file = $rss2forumfile; }

	open(OUT,"> $rss2file") || &error("Write Error: $rss2file");
	eval "flock(OUT, 2);";
	seek(OUT, 0, 0);
	print OUT &strEncode($out, $feed_code);
	truncate(OUT, tell(OUT));
	close(OUT);

}

# Atom1.0
sub atom {

	# 引数に最大件数を追加 （2009/10/27 スガラボット追加修正)
	my ($bbs, $thno, $max_feed) = @_;

	# 閲覧するトップページが'patio'か'forum'かによってリンク先を変える
	my $atomurl;
	if ($bbs eq 'patio' || $fb eq 'patio') {
		$bbsurl = "$url_root$patioshtml";
		$bbsurl =~ s/&/&amp;/g;
		$atomurl = "$url_root$atompatiourl";
	} elsif ($bbs eq 'forum' || $fb eq 'forum') {
		$bbsurl = "$url_root$forumshtml";
		$bbsurl =~ s/&/&amp;/g;
		$atomurl = "$url_root$atomforumurl";
	}

	# もしスレッド閲覧ページからのアクセスならこのFEEDのURLはダイナミックなものに変更
	if ($max_feed) {
		$atomurl = "$url_root$readcgi&feed=atom&no=$thno";
		$atomurl =~ s/&/&amp;/g;
		$feed_title = "${title} - [スレッドNo.${thno}] 新規投稿のお知らせ";
	} 

	my ($out, $out1, $out2);
	my ($feed_code) = $atom_code;

	&xml;

	my($tagdate) = substr($w3cudate,0,10);

	$out1 .= <<"EOM";
<feed xmlns="http://www.w3.org/2005/Atom">
  <title>$feed_title</title>
  <subtitle>$feed_des</subtitle>
  <id>tag:$dns\,$tagdate:$lname</id>
  <link rel="alternate" type="application/xhtml+xml" href="$bbsurl"/>
  <link rel="self" type="application/atom+xml" href="$atomurl"/>
  <updated>$w3cdate</updated>
EOM

	# スレッド閲覧ページの最大件数は $max_feed、トップページとの最大件数は$feed_num とする (2009/10/27 スガラボット追加修正)
	our ($feed_cnt, $readurl2);
	if ($max_feed) { $feed_cnt = $max_feed; }
	else { $feed_cnt = $feed_num; }

	my ($bbsflg, $tflag);
	if ($max_feed) { $feed_cnt = $max_feed; }
	else {
		$feed_cnt = $feed_num;
		$bbsflg = "bbs=$bbs";
		if ($bbs eq 'forum') { $tflag = '&amp;tree=1'; }
	}

	our ($published, $naiyo1, $naiyo2, $t_first, $tagdate);
	our ($num,$rno,$tsub,$sub,$rfcdate,$pdate,$w3cdate,$nam,$com,$resto);
	for($i = 0; $i <= $#feed; $i++) {
		($num,$rno,$tsub,$sub,$rfcdate,$pdate,$w3cdate,$nam,$com,undef,$resto) = split(/<>/, $feed[$i]);

		my $sub0 = $sub;
		# 最新記事のスレッド番号、返信番号、投稿者、タイトル、日付を取得しておく
		if ($i == 0) {
			&edititem( 'top' );
			
	$out1 .= <<"EOM";
    <entry>
      <author>
        <name>$nam</name>
      </author>
      <title>${title}のスレッド一覧</title>
      <link href="$bbsurl"/>
      <id>tag:$dns\,$tagdate:$lname</id>
      <published>$rfcdate</published>
      <updated>$w3cdate</updated>
      <summary>$naiyo1</summary>
    </entry>
EOM
		}

		# スレッド番号が負の数字なら過去ログのためスキップ	（2009/10/27 スガラボット追加修正)
		if (substr($num, 0, 1) eq '-') { next; }

		# スレッド閲覧ページからのRSSフィード作成なら指定スレッド番号以外の記事はスキップ	（2009/10/28 スガラボット追加修正)
		if ($thno && $thno ne $num) { next; }

		# patio.cgi のスレッド一覧から要求されたときは返信番号、投稿者、タイトル、日付を取得しておく
		if (!$t_first) {
			$t_first = 1;
			$sub = $sub0;
			&edititem;
			
		$patiocgi =~ s/&/&amp;/g;
		$out1 .= <<"EOM";
    <entry>
      <title>${title}のスレッドNo.${in{'no'}} タイトル一覧</title>
      <link href="$url_root$patiocgi&amp;view=thread&amp;no=$thno"/>
      <id>tag:$dns\,$tagdate:$lname$num</id>
      <published>$rfcdate</published>
      <updated>$w3cdate</updated>
      <summary>$naiyo2</summary>
    </entry>
EOM
		}

		# 最大出力数制御 ($feed_cntが0になったら終了)
		if ($feed_cnt) { $feed_cnt--; }
		else { last; }

		$sub = $sub0;
		&edititem;

		if($rno) { $readurl2 = "$readurl&amp;$bbsflg&amp;no=$num&amp;l=-$rno&amp;rev=1"; }
		else { $readurl2 = "$readurl&amp;$bbsflg$tflag&amp;no=$num"; }

		$out2 .= <<"EOM";
     <entry>
       <author>
         <name>$nam</name>
       </author>
       <title>$sub</title>
       <link href="$readurl2"/>
       <id>tag:$dns\,$tagdate:$lname$num-$rno</id>
       $published<updated>$w3cdate</updated>
       $updated<summary type="html">$com</summary>
     </entry>
EOM
	}

		# スレッド一覧表示ページ
	my $t_title;
	if ($tsub0 && ($tsub0 ne $sub0)) {
		$t_title = "【テーマ：${tsub0}】";
	}


	# patio.cgi のスレッド一覧から要求されたときはスレッド一覧ページを表示する (2009/11/26 スガラボット追加修正)
	my $th_title;
	if ($tsub_t0 && ($tsub_t0 ne $sub_t0)) {
		$th_title = "【テーマ：${tsub_t0}】";
	}

	if ($in{'view'} eq 'thread') {
	}

	$out .= $out1 . $out2;
	$out .= "</feed>";

	# スレッド閲覧ページからの起動ならファイルを作成せずにリターン （2009/10/27 スガラボット追加修正)
	if ($max_feed) { return $out; }

	# 引数"$bss"によって作成するファイルを決める
	my $atomfile;
	if ($bbs eq 'patio') { $atomfile = $atompatiofile; }
	elsif ($bbs eq 'forum') { $atomfile = $atomforumfile; }

	open(OUT,"> $atomfile") || &error("Write Error: $atomfile");
	eval "flock(OUT, 2);";
	seek(OUT, 0, 0);
	print OUT &strEncode($out, $feed_code);
	truncate(OUT, tell(OUT));
	close(OUT);

}

# ログ更新準備
sub pre {

	# 引数があったときは引数を$fcomに代入
	if (@_) { ($fcom) = @_; }
	else { &date_time(); }

	# 本文のBBCodeを削除 （2009/01/14 スガラボット修正)
	$fcom = &bbcoderm($fcom);
	
	# ">"で始まる引用行を削除 (文字数制限のある場合、新着記事で最初の引用文は表示しない)
	if ($len) {
		$fcom =~ s/<br>/\n/g;
		$fcom =~ s/^&gt;.*?\n//mg;
	}

	if ($len && (length($fcom) >= $len)) {
		$fcom = substr($fcom,0,$len) ;
		$fcom .= "...";
	}

	# 本文の改行タグをRSS用に変換
	$fcom =~ s/\n/&lt;br \/&gt;/mg;

	if ($reg_upl || $edit_upl) { $fcom = $mark . '&lt;br /&gt;' . $fcom; }
	$fflag = 1 ;
}

# XML宣言
sub xml {
#	if ($feed_code == 3) {	#}
	if ($feed_code eq 'utf8') {
		$out = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
#	} elsif ($feed_code) {	#}
	} elsif ($feed_code eq 'euc') {
		$out = "<?xml version=\"1.0\" encoding=\"EUC-JP\"?>\n";
	} elsif ($feed_code eq 'jis') {
		$out = "<?xml version=\"1.0\" encoding=\"iso-2022-jp\"?>\n";
#	} else {	#}
	} elsif ($feed_code eq 'sjis') {
		$out = "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n";
	}
}

# 日付
sub date_time {
	# 引数がなければ現在時刻を取得、あればその引数(Unixタイム)を元にフォーマットを作成 （2009/10/30 スガラボット追加修正)
	my ($tm) = @_;
	my $tm_flag;
	if (!$tm) { $tm = time(); $tm_flag = 1; }

	my @t = localtime($tm);
	my($year,$mon,$mday,$hour,$min,$sec,$wday) = ($t[5]+1900, $t[4]+1, $t[3], $t[2], $t[1], $t[0], $t[6]);
	my $dname = ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat")[$wday];
	my $mname  = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")[$mon - 1];
	$rfc822 = sprintf("$dname, %02d $mname $year %02d:%02d:%02d +0900",$mday,$hour,$min,$sec);
	$w3cdtf = sprintf("$year-%02d-%02dT%02d:%02d:%02d+09:00",$mon,$mday,$hour,$min,$sec);
	if ( !$tm_flag ) { $tm = time(); }
	@t = localtime($tm);
	($year,$mon,$mday,$hour,$min,$sec,$wday) = ($t[5]+1900, $t[4]+1, $t[3], $t[2], $t[1], $t[0], $t[6]);
	$bakdate = sprintf("$year%02d%02d%02d%02d", $mon,$mday,$hour,$min);
}

#############################
# サブルーチン log_create
#############################

sub log_create {

	# feed.logを作成するための配列は行番号とログ内容の二次元配列とする
	local (@tp, $top, @flog, @order);

	open(TP,"$nowfile") || &error("Open Error: $nowfile");

	eval "flock(TP, 2);";
	$top = &lineDecode(TP);
	@tp = &arrayDecode(TP);
	close(TP);

	# 過去ログも連結する
	open(TP,"$pastfile") || &error("Open Error: $pastfile");

	eval "flock(TP, 2);";
	push(@tp, &arrayDecode(TP));
	close(TP);

	local $ftime;
	(undef, undef, $ftime) = split(/<>/, $top);

	local $line = 0;
	local ($i, @tnum);
	for ($i=0; $i<=$#tp; $i++) {

		local (@log, $tnum, $restime);

		($tnum[$i], undef, undef, undef, undef, undef, undef, undef, undef, $restime) = split(/<>/, $tp[$i]);

		&date_time($restime);

		# スレッド読み込み
		open(IN, "< $logdir/$tnum[$i].cgi") || &error("Open Error: $logdir/$tnum[$i].cgi");
		eval "flock(IN, 2);";

		@log = &arrayDecode(IN);
		close(IN);

		my $top1 = $log[0];
		my ($num, $tsub0, $res, $key) = split(/<>/, $top1);

		# もし過去ログならスレッド番号の先頭に"-"を付ける
		if ($key < 0) { $tnum = '-' . $tnum; }

		local ($sub0, $tsub, $tsubflg);
		for (my $j=1; $j<=$#log; $j++) {
			chomp($log[$j]);

			my (@no,@sub,@nam,@eml,@com,@dat,@ho,@pw,@url,@mvw,@myid,@tim,@upl,@idcrypt,@color,@resto);
			($no[$j],$sub[$j],$nam[$j],$eml[$j],$com[$j],$dat[$j],$ho[$j],$pw[$j],$url[$j],$mvw[$j],
					$myid[$j],$tim[$j],$upl[1][$j],$upl[2][$j],$upl[3][$j],$idcrypt[$j],$color[$j],$resto[$j])  = split(/<>/, $log[$j]);

			if ($j == 1) {
				if ($tsub0 eq $sub[$j]) { 
					$tsub = "";
					$sub0 = $sub[$j];
					$tsubflg = 1;
				} else {
					$tsub = $tsub0;
				}
			} else {
				if ($tsubflg) { $tsub = "<0>$sub0"; }
				else { $tsub = $tsub0; }
			}

			$reg_upl = '';
			my ($ex1, $ex2, $ex3);
			($ex1) = split(/,/, $upl[1][$j]);
			($ex2) = split(/,/, $upl[2][$j]);
			($ex3) = split(/,/, $upl[3][$j]);
			if ($ex1 || $ex2 || $ex3) { $reg_upl = $tim[$j]; }
			
			&date_time($tim[$j]);
			&pre($com[$j]);

			my $temp = "$tnum[$i]<>$no[$j]<>$tsub<>$sub[$j]<>$w3cdtf<>$rfc822<>$w3cdtf<>$nam[$j]<>$fcom<>$reg_upl<>$resto[$j]<>\n";

			push(@order, "$tim[$j]<>$line");
			push(@flog, $temp);

			$line++;
		}
	}

	# @orderをタイムスタンプの新しいものから並べ直す
	local @order_sort = sort { $b cmp $a } @order;

	local @new = ();
	for (my $i=0; $i<$line; $i++) {
		my (undef, $j) = split(/<>/, $order_sort[$i]);
		push(@new, $flog[$j]);
	}
	
	&date_time($ftime);
	$pubdate = $rfc822;
	$w3cdate = $w3cdtf;

	unshift(@new, "$pubdate<>$pubdate<>$w3cdate<>$w3cdate<>\n");
	@feed = @new;

	open(OUT,"> $feedlog") || &error("Open Error: $feedlog");
	print OUT &arrayEncode(\@new, $logchar);
	truncate(OUT, tell(OUT));
	close(OUT);

}

#############################
# サブルーチン edititem
#############################

sub edititem {
	my ($top) = @_;

	# 返信記事の場合、返信元の記事を指定
	if ($rno && $resto) { $sub = $sub . " [記事No.${resto}への返信]"; }

	# #tsub, $sub のBBCodeを削除
	$sub = &titlebbrm($sub);
	$tsub = &titlebbrm($tsub);

	# 発行日と更新日が異なるとき
	my ($kiji, $post, $joshi);
	if ($rfcdate ne $w3cdate) {
		$w3cdate =~ s/-/\//g;
		$w3cdate =~ s/T/ /;
		$w3cdate =~ s/\+.*//;
		$com = "【更新:${update}】&lt;br /&gt;" . $com;
		my $temp = '】&lt;br /&gt;【';
		$com =~ s/$temp/　/;
		$kiji = "記事";
		$post = "更新";
		$thread = "更新スレッド";
		$joshi = "の";
		$published = "<published>$rfcdate</published>\n";
	} else {
		$kiji = "新着記事";
		$post = "投稿";
		$thread = "新スレッド";
		$joshi = "に";
	}

	# スレッド一覧表示ページ
	my $t_title;
	if ($tsub) {
		if ($tsub =~ /<0>/) { $tsub =~ s/<0>//; }
		if ($tsub ne $sub) { $t_title = "【テーマ：${tsub}】"; }
	}

	# 返信番号がゼロのときは元発言と表記する
	my $kiji_no;
	if (!$rno) { $kiji_no = "元発言"; }
	else { $kiji_no = "No.${rno} 記事"; }

	# 記事またはスレッドが投稿/更新/削除されたとき
	if ( substr($num, 0, 1) eq '-' ) {
		$naiyo1 = "掲示板トップページ：No.${num} スレッド ${t_title} の ${kiji_no} 【タイトル：${sub}】 が削除されました。" ;
		$naiyo2 = "スレッド No.${in{'no'}} ${th_title} の ${kiji_no} 【タイトル：${sub}】 が削除されました。" ;
	} else {
		$naiyo1 = "掲示板トップページ：No.${num}スレッド ${t_title} ${joshi} ${kiji_no} 【タイトル：${sub}】 が${post}されました。" ;
		$naiyo2 = "スレッド No.${in{'no'}} ${th_title} ${joshi} ${kiji_no} 【タイトル：${sub}】 が${post}されました。" ;
	}

	# スレッドテーマ分離によりタイトル表示の修正 （2009/10/22 スガラボット追加修正)
	if ($tsub) {
		if ($tsub =~ /<0>/) {
			$tsub =~ s/<0>//;
			if ($rno) { $sub = "${kiji}：No.${num}-${rno} 【タイトル：${sub}】 が${post}されました。\n → No.${num} スレッド 【題名：${tsub}】 を記事 No.${rno} から新着順に閲覧 "; }
			else { $sub = "スレッド No.${num} 【テーマ：${tsub}】 の元発言 【タイトル：${sub}】 が${post}されました。\n → ${thread} No.${num} を閲覧 "; }
		}
		else {
			if ($rno) { $sub = "${kiji}：No.${num}-${rno} 【タイトル：${sub}】 が${post}されました。\n → No.${num} スレッド 【テーマ：${tsub}】 を記事 No.${rno} から新着順に閲覧 "; }
			else { $sub = "スレッド No.${num} 【テーマ：${tsub}】 の元発言 【タイトル：${sub}】 が${post}されました。\n → ${thread} No.${num} を閲覧 "; }
		}
	}
	else {
		if ($rno) {}
		else { $sub = "スレッド：No.${num} の元発言 【${sub}】 が${post}されました。\n → ${thread} No.${num} を閲覧 "; }
	}

	# 名前の BBCode を削除
	$nam = &titlebbrm($nam);

	$tagdate = substr($rfcdate,0,10);

	# 管理者による修正削除のときは記事の更新削除記録ではなく管理者処理のサマリーをトップページに一回だけ記述する
	if ( ($top eq 'top') && ($in{'myjob'} eq 'admin' || $job eq 'admin' || $job eq "renumber") ) {

		$nam = "管理者";

		if ( $job eq 'edit' ) {
			$kiji_no = $in{'no'} ? "No.$in{'no'} 記事" : "元発言";
			$naiyo1 = "管理者によって No.$in{'f'} スレッドの ${kiji_no}が修正されました";
		} 
		elsif ( $job eq 'del' ) {
			$kiji_no = '';
			my $comma = '';
			foreach my $del ( @del ) {
				my $kno = $del ? "No.$del 記事" : "元発言";
				$kiji_no .= $comma . $kno;
				$comma = "、";
			}
			$naiyo1 = "管理者によって No.$in{'f'} スレッドの ${kiji_no}が削除されました";
		} 
		elsif ( $job eq 'admin' ) {
			my $tno = '';
			my $comma = '';
			if ( !@del ) { @del = @lock; }
			foreach my $del ( @del ) {
				$tno .= $comma . "No.$del スレッド";
				$comma = "、";
			}
			if ( !$past ) {
				$naiyo1 = "管理者によって ${tno}が一括削除されました";
			} 
			elsif ( $past eq '-1' ) {
				$naiyo1 = "管理者によって ${tno}が過去ログへ移動されました";
			}
			elsif ( $past eq '1' ) {
				$naiyo1 = "管理者によって ${tno}が過去ログから復帰されました";
			}
		}
		elsif($job eq "renumber") {
			if ( $in{'job'} eq 'renumber' ) {
				$naiyo1 = "管理者によって No.$in{'no'} スレッドが No.$to_thread スレッドに改番されました";
			}
			elsif ( $in{'job'} eq 'split' ) {
				my $from;
				if ( !$in{'no2'} ) { $from = "No.$in{'no'} スレッド全記事が"; }
				else { $from = "No.$in{'no'} スレッドの No.$in{'no2'}記事以降を分割して"; }

				if ( $new_thread ) { 
					$naiyo1 = "管理者によって ${from}新規に No.$to_thread スレッドとして独立しました"; }
				else { 
					my $kiji_no;
					if ( !$in{'to_res'} ) { $kiji_no = "元発言"; }
					else { $kiji_no = " No.$in{'to_res'} 記事"; }
					$naiyo1 = "管理者によって ${from} No.${to_thread} スレッド${kiji_no}への返信として連結されました";
				}
			}
		}
	}
}

1;
