#!/usr/local/bin/perl
#┌─────────────────────────────────
#│ [ WebPatio ]
#│ patio.cgi - 2006/10/09
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#└─────────────────────────────────
#
# きりしま式 Web Patio v3.22 k0.92 相当 2009/4/18
# 2009/04/01 FAQモード追加修正
$kver = '_3.22_k0.92';
$sver = 'v1.43';
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義ヘッダー対応のコラム背景画像クラスを追加
# 2009/07/05 CGIスクリプトをUnicode記述に変更。HTML入出力とログファイルの文字コード(utf8,sjis,euc,jis)を設定可能

#use strict;
#use warnings;
#use Time::Local;
use utf8;

# 外部ファイル取り込み
require './init.cgi';
#require $jcode;
require $checkpl;

# SSIによる複数会議室対応かどうか (20080315 スガラボット修正)
if (!$patioshtml) { $patioshtml = $patiocgi; }
if (!$forumshtml) { $forumshtml = $forumcgi; }
if (!$readshtml) { $readshtml = $readcgi; }
if (!$bbsshtml) { $bbsshtml = $bbscgi; }

# BBCode処理の変数関数を選択 (2009/01/14 スガラボット修正)
if ($bbcode) { $titlebb ="bbtitle"; } 
else { $titlebb = "titlebbrm"; }

# 携帯からのアクセスかどうかを判定
	# PCからアクセスした時。($ua=0 はPC 1～6は携帯)
	if (!$ua && $treeforum)
	{
		$tree = 1;
		$width = "width=\"95%\"";
	}
	# 携帯からアクセスした時
	else {
		$tree = 0;
		$width = "width=\"100%\"";
	}

&parse_form;

# 掲示板共通の留意事項がアクセスされるときはこのCGIを起動して戻り会議室名などをパラメータとして付加する。
if ($in{'target'} eq 'note') {

	# 共通の留意事項htmlファイルをオープン
	open(DAT, "< $root_dir$notepage0") || &error("留意事項ファイルが開けません: file=$root_dir$notepage0");
	local @out = ();
	local @txt = <DAT>;
	close(DAT);
	foreach (@txt) {

		# 画像ディレクトリを変換
		my $img = 'img';
		if (/\.\.\/img/) { $img = '\.\.\/img'; }
		s/$img\//$imgurl\//g;

		# 掲示板トップへのリンクを変換
		s/<A href=".*cgi-bin\/patio\.cgi">/<A href="$bbscgi">/ig;

		# 掲示板の設定内容を表示するリンクに戻り会議室などのパラメータを付加
		s/<A href=".*cgi-bin\/setting\.cgi">/<A href="$settingcgi">/ig;
		push(@out, $_);
	}
	print "Content-type: text/html\n\n";
# デバッグプリント
#	print ("sub_dir=$sub_dir, <br>notepage=$notepage, <br>notepage0=$notepage0, <br>file=$root_dir$notepage0\n"); exit;
	print @out;
	exit;
}

	my $pagetitle = $title ? $title."の設定内容チェック" : "掲示板の設定内容チェック";

&header();

	$printString = <<"EOM";
<div align="center">
<table $width><tr><td align=right nowrap>
<a href="$bbsshtml">トップページ</a> &gt; <a href="$notepage">留意事項</a> &gt; 設定内容
</td></tr></table>
<div align="center">
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/book.gif" align="top">
&nbsp; <b>$pagetitle</b></td>
<td $bgclass2 align="right" bgcolor="$col3" nowrap>
<a href="javascript:history.back()">前画面に戻る</a></td>
</tr></table>
<p>
EOM
print &strEncode($printString);

&setting;

