#!/usr/local/bin/perl

# ダウンロード数表示CGI
# ファイル名: showcount.cgi
# 作成者: スガラボット
# 作成日: 2008/03/28

use strict;
use warnings;
use utf8;

our $sver = "v1.03";
# 2008/10/29 新規に v1.03として配布

	our ($logchar, $charset);
	our ($bg, %in, $root_dir, $sub_dir, $home_root, $postflag);

	require 'init.cgi';

#	$logchar = 'utf8';
#	$charset = 'utf8';

	&parse_form;

	my $dir = $in{'dir'};

	my $target = $dir . '/' . $in{'fn'};
	
	my $htmlcode = &htmlchar($charset);

	open(my $DAT, "< $target") || &error("error: Server couldn't open $target<br>ダウンロードされた記録がありません");

	my $total = 0;
	$total = <$DAT>;
	chomp ($total);

my $body;
if ($main::bg) {
	$body = "<BODY background=\"$main::bg\" bgcolor=\"$main::bc\">\n";
} else {
	$body = "<BODY bgcolor=\"$main::bc\">\n";
}

	my $printString = <<"EOM";
Content-Type: text/html\n\n
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">\n
<HTML>\n
<HEAD>\n
<META http-equiv="Content-Type" content="text/html; charset=$htmlcode">\n
<META http-equiv="Content-Style-Type" content="text/css">\n
<TITLE>ダウンロード</TITLE>\n
</HEAD>\n
$body
<h4>${dir}のカウント数</h4>\n
file=$target<br>
<table border="1">\n
<tr><th>ターゲット名</th><th>ダウンロード数</th></tr>\n
EOM
print &strEncode($printString);

	my $i = 0;
	my $flag = 0;
	my $id = '';
	my $num = 0;
	my $buf;
	while ( $buf = &lineDecode($DAT) ) {
		$i++;
		chomp($buf);
		my($id, $num) = split(/<>/, $buf);
		
		print &strEncode("<tr><td align=\"right\">$id</td><td align=\"right\">$num</td></tr>\n");
	}
	
	print &strEncode("<tr><td align=\"right\">トータル</td><td align=\"right\">$total</td></tr>\n");
	print "</table></body></html>\n";
	
	close($DAT);


1;

