##########################################################
# revoconfig.cgi v1.50
# Copyright(C): Sugarabotto
# リリース: 2012/07/18
# http://vmorita.com/bbs/patio/
# 
# この掲示板のビューカウンタは futomi's CGI Cafe さんの RevoCounter CGI の改造版です
# オリジナル; RevoCounter Ver 1.4
# Copyright(C) futomi 2001 - 2009
# http://www.futomi.com/library/revocount.html
# CGI利用規程：http://www.futomi.com/library/kitei.html
# (この CGI は futmi's CGI Cafe さんの許可を得て再配布しています)
##########################################################

#----------------------------------------------------------------
# ● 表示桁数の設定
# 設定桁数にカウント値が満たない場合には、左から0が表示されます。
# たとえば、桁数設定が「6」で、カウント値が「1234」の場合には、
# 「001234」と表示されます。
#----------------------------------------------------------------
#$Figures = 6;
$Figures = 5;


#----------------------------------------------------------------
# ● 表示桁数固定・非固定の設定
# 表示桁数を、カウント値が超えた場合に、表示桁数を自動的に増やすか
# もしくは固定にするかを指定します。
# たとえば、表示桁数設定が「6」で、カウント値が「999999」から
# 「1000000」にアップする際に、
# 非固定であれば、「1000000」と7桁で表示され、
# 固定であれば、「000000」と6桁で表示されます。
# 非固定の場合には、「0」、固定の場合には、「1」を指定してください。
#----------------------------------------------------------------
$FiguresFixFlag = 0;


#----------------------------------------------------------------
# ● アニメーションの時間指定[ms]
# カウント値がアップする際の、アニメーションの時間を指定できます。
# 10ミリ秒単位で、指定してください。2秒の場合には、「200」と指定します。
# 【注意】ここでの指定はあくまでも目安です。通信速度やパソコンの
#         スペックなどの諸条件により、指定どおりとはならない場合が
#         ありえます。
#----------------------------------------------------------------
$AniTime = 100;


#----------------------------------------------------------------
# ● 透過色指定（16進数）
# アニメーションカウンターは、透過GIFにすることができます。
# 透過色を16進数（6桁）で指定してください。
# 【例】
#     $TransparentColor = 'FFFFFF';
#     透過色を指定しない場合には、
#     $TransparentColor = '';
#----------------------------------------------------------------
$TransparentColor = 'FFFFFF';


#----------------------------------------------------------------
# ● Cookieによるカウントアップ防止機能（使わない:0, 使う:1）
# 同じ人がアクセスしたり、ブラウザーで再読込をしても、カウンター
# の値をアップしないようにできます。
# この防止機能を使わない場合には、「0」を
# 使う場合には、「1」を指定して下さい。
# 【注意】 ここの設定を有効にしても、Cookieを無効にしている
#          ブラウザーに対しては、効きません。
#----------------------------------------------------------------
$CookieFlag = 1;


#----------------------------------------------------------------
# ● カウントしないガード時間
# 以前サイトにアクセスしてから、ここで指定したガード時間を超え
# ずに、再度アクセスした場合には、カウンター値がアップしません。
# 逆に、超えている場合には、カウンター値はアップします。
# この設定は、Cookieによるカウントアップ防止機能が有効になっている
# 場合に、有効となります。
# 単位は、時間です。
# $GuardTime = 6;
# と指定すれば、6時間を意味します。
#----------------------------------------------------------------
$GuardTime = 6;


#----------------------------------------------------------------
# ● URLガードフラグ（使わない:0, 使う:1）
# あなたが設定したこのCGIを、他人に勝手に使われないようにするため
# の機能です。
# この機能を無効にする場合には「0」を、有効にする場合には、「1」
# を指定して下さい。他人にカウンターを悪用されないためにも、有効に
# することをお勧めします。有効にした場合には、下の「あなたのホーム
# ページのURLを正しく設定してください。
# 【注意】この機能は、ブラウザーが送信する環境変数「HTTP_REFERER」
#         を使います。したがって、「HTTP_REFERER」を送信しない
#         クライアント（i-mode端末等）に対しては、カウンターが表示
#         されなくなります。
#----------------------------------------------------------------
#$UrlGuardFlag = 0;
$UrlGuardFlag = 0;


#----------------------------------------------------------------
# ● あなたのホームページのURL
# URLガードフラグが有効になっている場合に、ここで指定したサイト
# からのみ、このCGIが動作するようになります。ここで指定したサイト
# 以外からは、このCGIが使えません。
# ここで指定したサイトの配下のページでは、すべてこのCGIを使うことが
# できます。
# たとえば、あなたのサイトのURLが http://www.hoge.co.jp/foo/
# であれば、
# $YourSiteUrl = 'http://www.hoge.co.jp/foo';
# と指定します。
# (ご注意!!)
# URLガードフラグ を "=1" に設定して、counter.cgi を Forum Patio 
# 掲示板だけでなく、ホームページ全体からアクセスするときは、
# ここで必ず、ホームページのルートURLを設定して下さい。
#----------------------------------------------------------------
#$YourSiteUrl = 'http://localhost';
$YourSiteUrl = 'http://www.exsample.com';



1;
